Scene (JavaFX 27)
Description: declaration: module: javafx.graphics, package: javafx.scene, class: Scene

# Class Scene

java.lang.Object
javafx.scene.Scene

All Implemented Interfaces:
  `EventTarget`

@DefaultProperty("root") public class Scene extends Object implements EventTarget
The JavaFX `Scene` class is the container for all content in a scene graph. The background of the scene is filled as specified by the `fill` property.

The application must specify the root `Node` for the scene graph by setting the `root` property. If a `Group` is used as the root, the contents of the scene graph will be clipped by the scene's width and height and changes to the scene's size (if user resizes the stage) will not alter the layout of the scene graph. If a resizable node (layout `Region` or `Control`) is set as the root, then the root's size will track the scene's size, causing the contents to be relayed out as necessary.

The scene's size may be initialized by the application during construction. If no size is specified, the scene will automatically compute its initial size based on the preferred size of its content. If only one dimension is specified, the other dimension is computed using the specified dimension, respecting content bias of a root.

An application may request depth buffer support or scene anti-aliasing support at the creation of a `Scene`. A scene with only 2D shapes and without any 3D transforms does not need a depth buffer nor scene anti-aliasing support. A scene containing 3D shapes or 2D shapes with 3D transforms may use depth buffer support for proper depth sorted rendering; to avoid depth fighting (also known as Z fighting), disable depth testing on 2D shapes that have no 3D transforms. See `depthTest` for more information. A scene with 3D shapes may enable scene anti-aliasing to improve its rendering quality.

The depthBuffer and antiAliasing flags are conditional features. With the respective default values of: false and `SceneAntialiasing.DISABLED`. See `ConditionalFeature.SCENE3D` for more information.

A default headlight will be added to a scene that contains one or more `Shape3D` nodes, but no light nodes. This light source is a `Color.WHITE` `PointLight` placed at the camera position.

A `Scene` may be created and modified on any thread until it is attached to a `Window` that is `showing`. After that, it must be modified only on the JavaFX Application Thread. Note that `Scene` is not thread-safe; modifying a `Scene` on multiple threads at the same time will lead to unpredictable results and must be avoided.

The JavaFX Application Thread is created as part of the startup process for the JavaFX runtime. See the `Application` class and the `Platform.startup(Runnable)` method for more information.

Example:

    import javafx.scene.*;
    import javafx.scene.paint.*;
    import javafx.scene.shape.*;

    Group root = new Group();
    Scene s = new Scene(root, 300, 300, Color.BLACK);

    Rectangle r = new Rectangle(25,25,250,250);
    r.setFill(Color.BLUE);

    root.getChildren().add(r);

Since:
  JavaFX 2.0

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `Scene.Preferences`
  Contains scene preferences that can override `platform` preferences.

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final ObjectProperty<Camera>`
  `camera`
  Specifies the type of camera use for rendering this `Scene`.
  `final ObjectProperty<Cursor>`
  `cursor`
  Defines the mouse cursor for this `Scene`.
  `final ReadOnlyObjectProperty<NodeOrientation>`
  `effectiveNodeOrientation`
  The effective node orientation of a scene resolves the inheritance of node orientation, returning either left-to-right or right-to-left.
  `final ObjectProperty<EventDispatcher>`
  `eventDispatcher`
  Specifies the event dispatcher for this scene.
  `final ObjectProperty<Paint>`
  `fill`
  Defines the background fill of this `Scene`.
  `final ReadOnlyObjectProperty<Node>`
  `focusOwner`
  The scene's current focus owner node.
  `final ReadOnlyDoubleProperty`
  `height`
  The height of this `Scene`
  `final ObjectProperty<NodeOrientation>`
  `nodeOrientation`
  Node orientation describes the flow of visual data within a node.
  `final ObjectProperty<EventHandler<? super ContextMenuEvent>>`
  `onContextMenuRequested`
  Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onDragDetected`
  Defines a function to be called when drag gesture has been detected.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragDone`
  Defines a function to be called when this `Scene` is a drag and drop gesture source after its data has been dropped on a drop target.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragDropped`
  Defines a function to be called when the mouse button is released on this `Scene` during drag and drop gesture.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragEntered`
  Defines a function to be called when drag gesture enters this `Scene`.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragExited`
  Defines a function to be called when drag gesture exits this `Scene`.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragOver`
  Defines a function to be called when drag gesture progresses within this `Scene`.
  `final ObjectProperty<EventHandler<? super InputMethodEvent>>`
  `onInputMethodTextChanged`
  Defines a function to be called when this `Node` has input focus and the input method text has changed.
  `final ObjectProperty<EventHandler<? super KeyEvent>>`
  `onKeyPressed`
  Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been pressed.
  `final ObjectProperty<EventHandler<? super KeyEvent>>`
  `onKeyReleased`
  Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been released.
  `final ObjectProperty<EventHandler<? super KeyEvent>>`
  `onKeyTyped`
  Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been typed.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseClicked`
  Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragDone`
  Defines a function to be called when a full press-drag-release gesture ends.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragEntered`
  Defines a function to be called when a full press-drag-release gesture enters this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragExited`
  Defines a function to be called when a full press-drag-release gesture exits this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseDragged`
  Defines a function to be called when a mouse button is pressed on this `Scene` and then dragged.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragOver`
  Defines a function to be called when a full press-drag-release gesture progresses within this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragReleased`
  Defines a function to be called when a full press-drag-release gesture ends within this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseEntered`
  Defines a function to be called when the mouse enters this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseExited`
  Defines a function to be called when the mouse exits this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseMoved`
  Defines a function to be called when mouse cursor moves within this `Scene` but no buttons have been pushed.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMousePressed`
  Defines a function to be called when a mouse button has been pressed on this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseReleased`
  Defines a function to be called when a mouse button has been released on this `Scene`.
  `final ObjectProperty<EventHandler<? super RotateEvent>>`
  `onRotate`
  Defines a function to be called when user performs a rotating action.
  `final ObjectProperty<EventHandler<? super RotateEvent>>`
  `onRotationFinished`
  Defines a function to be called when a rotating gesture ends.
  `final ObjectProperty<EventHandler<? super RotateEvent>>`
  `onRotationStarted`
  Defines a function to be called when a rotating gesture is detected.
  `final ObjectProperty<EventHandler<? super ScrollEvent>>`
  `onScrollFinished`
  Defines a function to be called when a scrolling gesture ends.
  `final ObjectProperty<EventHandler<? super ScrollEvent>>`
  `onScroll`
  Defines a function to be called when user performs a scrolling action.
  `final ObjectProperty<EventHandler<? super ScrollEvent>>`
  `onScrollStarted`
  Defines a function to be called when a scrolling gesture is detected.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeDown`
  Defines a function to be called when an downward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeLeft`
  Defines a function to be called when an leftward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeRight`
  Defines a function to be called when an rightward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeUp`
  Defines a function to be called when an upward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchMoved`
  Defines a function to be called when a touch point is moved.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchPressed`
  Defines a function to be called when a new touch point is pressed.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchReleased`
  Defines a function to be called when a new touch point is pressed.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchStationary`
  Defines a function to be called when a touch point stays pressed and still.
  `final ObjectProperty<EventHandler<? super ZoomEvent>>`
  `onZoomFinished`
  Defines a function to be called when a zooming gesture ends.
  `final ObjectProperty<EventHandler<? super ZoomEvent>>`
  `onZoom`
  Defines a function to be called when user performs a zooming action.
  `final ObjectProperty<EventHandler<? super ZoomEvent>>`
  `onZoomStarted`
  Defines a function to be called when a zooming gesture is detected.
  `final ObjectProperty<Parent>`
  `root`
  Defines the root `Node` of the scene graph.
  `final ObjectProperty<String>`
  `userAgentStylesheet`
  Gets the userAgentStylesheet property.
  `final ReadOnlyDoubleProperty`
  `width`
  The width of this `Scene`
  `final ReadOnlyObjectProperty<Window>`
  `window`
  The `Window` for this `Scene`
  `final ReadOnlyDoubleProperty`
  `x`
  The horizontal location of this `Scene` on the `Window`.
  `final ReadOnlyDoubleProperty`
  `y`
  The vertical location of this `Scene` on the `Window`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Scene(Parent root)`
  Creates a Scene for a specific root Node.
  `Scene(Parent root, double width, double height)`
  Creates a Scene for a specific root Node with a specific size.
  `Scene(Parent root, double width, double height, boolean depthBuffer)`
  Constructs a scene consisting of a root, with a dimension of width and height, and specifies whether a depth buffer is created for this scene.
  `Scene(Parent root, double width, double height, boolean depthBuffer, SceneAntialiasing antiAliasing)`
  Constructs a scene consisting of a root, with a dimension of width and height, specifies whether a depth buffer is created for this scene and specifies whether scene anti-aliasing is requested.
  `Scene(Parent root, double width, double height, Paint fill)`
  Creates a Scene for a specific root Node with a specific size and fill.
  `Scene(Parent root, Paint fill)`
  Creates a Scene for a specific root Node with a fill.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final <T extends Event>
  void`
  `addEventFilter(EventType<T> eventType, EventHandler<? super T> eventFilter)`
  Registers an event filter for this target.
  `final <T extends Event>
  void`
  `addEventHandler(EventType<T> eventType, EventHandler<? super T> eventHandler)`
  Registers an event handler for this target.
  `void`
  `addMnemonic(Mnemonic m)`
  Registers the specified mnemonic.
  `final void`
  `addPostLayoutPulseListener(Runnable r)`
  Adds a new scene post layout pulse listener to this scene.
  `final void`
  `addPreLayoutPulseListener(Runnable r)`
  Adds a new scene pre layout pulse listener to this scene.
  `EventDispatchChain`
  `buildEventDispatchChain(EventDispatchChain tail)`
  Construct an event dispatch chain for this target.
  `final ObjectProperty<Camera>`
  `cameraProperty()`
  Specifies the type of camera use for rendering this `Scene`.
  `final ObjectProperty<Cursor>`
  `cursorProperty()`
  Defines the mouse cursor for this `Scene`.
  `final ReadOnlyObjectProperty<NodeOrientation>`
  `effectiveNodeOrientationProperty()`
  The effective node orientation of a scene resolves the inheritance of node orientation, returning either left-to-right or right-to-left.
  `final ObjectProperty<EventDispatcher>`
  `eventDispatcherProperty()`
  Specifies the event dispatcher for this scene.
  `final ObjectProperty<Paint>`
  `fillProperty()`
  Defines the background fill of this `Scene`.
  `final ReadOnlyObjectProperty<Node>`
  `focusOwnerProperty()`
  The scene's current focus owner node.
  `ObservableMap<KeyCombination, Runnable>`
  `getAccelerators()`
  Gets the list of accelerators for this `Scene`.
  `final SceneAntialiasing`
  `getAntiAliasing()`
  Return the defined `SceneAntialiasing` for this `Scene`.
  `final Camera`
  `getCamera()`
  Gets the value of the `camera` property.
  `final Cursor`
  `getCursor()`
  Gets the value of the `cursor` property.
  `final NodeOrientation`
  `getEffectiveNodeOrientation()`
  Gets the value of the `effectiveNodeOrientation` property.
  `final EventDispatcher`
  `getEventDispatcher()`
  Gets the value of the `eventDispatcher` property.
  `final Paint`
  `getFill()`
  Gets the value of the `fill` property.
  `final Node`
  `getFocusOwner()`
  Gets the value of the `focusOwner` property.
  `final double`
  `getHeight()`
  Gets the value of the `height` property.
  `ObservableMap<KeyCombination, ObservableList<Mnemonic>>`
  `getMnemonics()`
  Gets the list of mnemonics for this `Scene`.
  `final NodeOrientation`
  `getNodeOrientation()`
  Gets the value of the `nodeOrientation` property.
  `final EventHandler<? super ContextMenuEvent>`
  `getOnContextMenuRequested()`
  Gets the value of the `onContextMenuRequested` property.
  `final EventHandler<? super MouseEvent>`
  `getOnDragDetected()`
  Gets the value of the `onDragDetected` property.
  `final EventHandler<? super DragEvent>`
  `getOnDragDone()`
  Gets the value of the `onDragDone` property.
  `final EventHandler<? super DragEvent>`
  `getOnDragDropped()`
  Gets the value of the `onDragDropped` property.
  `final EventHandler<? super DragEvent>`
  `getOnDragEntered()`
  Gets the value of the `onDragEntered` property.
  `final EventHandler<? super DragEvent>`
  `getOnDragExited()`
  Gets the value of the `onDragExited` property.
  `final EventHandler<? super DragEvent>`
  `getOnDragOver()`
  Gets the value of the `onDragOver` property.
  `final EventHandler<? super InputMethodEvent>`
  `getOnInputMethodTextChanged()`
  Gets the value of the `onInputMethodTextChanged` property.
  `final EventHandler<? super KeyEvent>`
  `getOnKeyPressed()`
  Gets the value of the `onKeyPressed` property.
  `final EventHandler<? super KeyEvent>`
  `getOnKeyReleased()`
  Gets the value of the `onKeyReleased` property.
  `final EventHandler<? super KeyEvent>`
  `getOnKeyTyped()`
  Gets the value of the `onKeyTyped` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMouseClicked()`
  Gets the value of the `onMouseClicked` property.
  `final EventHandler<? super MouseDragEvent>`
  `getOnMouseDragDone()`
  Gets the value of the `onMouseDragDone` property.
  `final EventHandler<? super MouseDragEvent>`
  `getOnMouseDragEntered()`
  Gets the value of the `onMouseDragEntered` property.
  `final EventHandler<? super MouseDragEvent>`
  `getOnMouseDragExited()`
  Gets the value of the `onMouseDragExited` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMouseDragged()`
  Gets the value of the `onMouseDragged` property.
  `final EventHandler<? super MouseDragEvent>`
  `getOnMouseDragOver()`
  Gets the value of the `onMouseDragOver` property.
  `final EventHandler<? super MouseDragEvent>`
  `getOnMouseDragReleased()`
  Gets the value of the `onMouseDragReleased` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMouseEntered()`
  Gets the value of the `onMouseEntered` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMouseExited()`
  Gets the value of the `onMouseExited` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMouseMoved()`
  Gets the value of the `onMouseMoved` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMousePressed()`
  Gets the value of the `onMousePressed` property.
  `final EventHandler<? super MouseEvent>`
  `getOnMouseReleased()`
  Gets the value of the `onMouseReleased` property.
  `final EventHandler<? super RotateEvent>`
  `getOnRotate()`
  Gets the value of the `onRotate` property.
  `final EventHandler<? super RotateEvent>`
  `getOnRotationFinished()`
  Gets the value of the `onRotationFinished` property.
  `final EventHandler<? super RotateEvent>`
  `getOnRotationStarted()`
  Gets the value of the `onRotationStarted` property.
  `final EventHandler<? super ScrollEvent>`
  `getOnScroll()`
  Gets the value of the `onScroll` property.
  `final EventHandler<? super ScrollEvent>`
  `getOnScrollFinished()`
  Gets the value of the `onScrollFinished` property.
  `final EventHandler<? super ScrollEvent>`
  `getOnScrollStarted()`
  Gets the value of the `onScrollStarted` property.
  `final EventHandler<? super SwipeEvent>`
  `getOnSwipeDown()`
  Gets the value of the `onSwipeDown` property.
  `final EventHandler<? super SwipeEvent>`
  `getOnSwipeLeft()`
  Gets the value of the `onSwipeLeft` property.
  `final EventHandler<? super SwipeEvent>`
  `getOnSwipeRight()`
  Gets the value of the `onSwipeRight` property.
  `final EventHandler<? super SwipeEvent>`
  `getOnSwipeUp()`
  Gets the value of the `onSwipeUp` property.
  `final EventHandler<? super TouchEvent>`
  `getOnTouchMoved()`
  Gets the value of the `onTouchMoved` property.
  `final EventHandler<? super TouchEvent>`
  `getOnTouchPressed()`
  Gets the value of the `onTouchPressed` property.
  `final EventHandler<? super TouchEvent>`
  `getOnTouchReleased()`
  Gets the value of the `onTouchReleased` property.
  `final EventHandler<? super TouchEvent>`
  `getOnTouchStationary()`
  Gets the value of the `onTouchStationary` property.
  `final EventHandler<? super ZoomEvent>`
  `getOnZoom()`
  Gets the value of the `onZoom` property.
  `final EventHandler<? super ZoomEvent>`
  `getOnZoomFinished()`
  Gets the value of the `onZoomFinished` property.
  `final EventHandler<? super ZoomEvent>`
  `getOnZoomStarted()`
  Gets the value of the `onZoomStarted` property.
  `final Scene.Preferences`
  `getPreferences()`
  Gets the scene preferences that can override `platform` preferences.
  `final ObservableMap<Object,Object>`
  `getProperties()`
  Returns an observable map of properties on this node for use primarily by application developers.
  `final Parent`
  `getRoot()`
  Gets the value of the `root` property.
  `final ObservableList<String>`
  `getStylesheets()`
  Gets an observable list of string URLs linking to the stylesheets to use with this scene's contents.
  `final String`
  `getUserAgentStylesheet()`
  Get the URL of the user-agent stylesheet that will be used by this Scene.
  `Object`
  `getUserData()`
  Returns a previously set Object property, or null if no such property has been set using the `setUserData(java.lang.Object)` method.
  `final double`
  `getWidth()`
  Gets the value of the `width` property.
  `final Window`
  `getWindow()`
  Gets the value of the `window` property.
  `final double`
  `getX()`
  Gets the value of the `x` property.
  `final double`
  `getY()`
  Gets the value of the `y` property.
  `boolean`
  `hasProperties()`
  Tests if Scene has properties.
  `final ReadOnlyDoubleProperty`
  `heightProperty()`
  The height of this `Scene`
  `final boolean`
  `isDepthBuffer()`
  Retrieves the depth buffer attribute for this scene.
  `Node`
  `lookup(String selector)`
  Looks for any node within the scene graph based on the specified CSS selector.
  `final ObjectProperty<NodeOrientation>`
  `nodeOrientationProperty()`
  Node orientation describes the flow of visual data within a node.
  `final ObjectProperty<EventHandler<? super ContextMenuEvent>>`
  `onContextMenuRequestedProperty()`
  Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onDragDetectedProperty()`
  Defines a function to be called when drag gesture has been detected.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragDoneProperty()`
  Defines a function to be called when this `Scene` is a drag and drop gesture source after its data has been dropped on a drop target.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragDroppedProperty()`
  Defines a function to be called when the mouse button is released on this `Scene` during drag and drop gesture.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragEnteredProperty()`
  Defines a function to be called when drag gesture enters this `Scene`.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragExitedProperty()`
  Defines a function to be called when drag gesture exits this `Scene`.
  `final ObjectProperty<EventHandler<? super DragEvent>>`
  `onDragOverProperty()`
  Defines a function to be called when drag gesture progresses within this `Scene`.
  `final ObjectProperty<EventHandler<? super InputMethodEvent>>`
  `onInputMethodTextChangedProperty()`
  Defines a function to be called when this `Node` has input focus and the input method text has changed.
  `final ObjectProperty<EventHandler<? super KeyEvent>>`
  `onKeyPressedProperty()`
  Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been pressed.
  `final ObjectProperty<EventHandler<? super KeyEvent>>`
  `onKeyReleasedProperty()`
  Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been released.
  `final ObjectProperty<EventHandler<? super KeyEvent>>`
  `onKeyTypedProperty()`
  Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been typed.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseClickedProperty()`
  Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragDoneProperty()`
  Defines a function to be called when a full press-drag-release gesture ends.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragEnteredProperty()`
  Defines a function to be called when a full press-drag-release gesture enters this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragExitedProperty()`
  Defines a function to be called when a full press-drag-release gesture exits this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseDraggedProperty()`
  Defines a function to be called when a mouse button is pressed on this `Scene` and then dragged.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragOverProperty()`
  Defines a function to be called when a full press-drag-release gesture progresses within this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseDragEvent>>`
  `onMouseDragReleasedProperty()`
  Defines a function to be called when a full press-drag-release gesture ends within this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseEnteredProperty()`
  Defines a function to be called when the mouse enters this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseExitedProperty()`
  Defines a function to be called when the mouse exits this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseMovedProperty()`
  Defines a function to be called when mouse cursor moves within this `Scene` but no buttons have been pushed.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMousePressedProperty()`
  Defines a function to be called when a mouse button has been pressed on this `Scene`.
  `final ObjectProperty<EventHandler<? super MouseEvent>>`
  `onMouseReleasedProperty()`
  Defines a function to be called when a mouse button has been released on this `Scene`.
  `final ObjectProperty<EventHandler<? super RotateEvent>>`
  `onRotateProperty()`
  Defines a function to be called when user performs a rotating action.
  `final ObjectProperty<EventHandler<? super RotateEvent>>`
  `onRotationFinishedProperty()`
  Defines a function to be called when a rotating gesture ends.
  `final ObjectProperty<EventHandler<? super RotateEvent>>`
  `onRotationStartedProperty()`
  Defines a function to be called when a rotating gesture is detected.
  `final ObjectProperty<EventHandler<? super ScrollEvent>>`
  `onScrollFinishedProperty()`
  Defines a function to be called when a scrolling gesture ends.
  `final ObjectProperty<EventHandler<? super ScrollEvent>>`
  `onScrollProperty()`
  Defines a function to be called when user performs a scrolling action.
  `final ObjectProperty<EventHandler<? super ScrollEvent>>`
  `onScrollStartedProperty()`
  Defines a function to be called when a scrolling gesture is detected.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeDownProperty()`
  Defines a function to be called when an downward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeLeftProperty()`
  Defines a function to be called when an leftward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeRightProperty()`
  Defines a function to be called when an rightward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super SwipeEvent>>`
  `onSwipeUpProperty()`
  Defines a function to be called when an upward swipe gesture happens in this scene.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchMovedProperty()`
  Defines a function to be called when a touch point is moved.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchPressedProperty()`
  Defines a function to be called when a new touch point is pressed.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchReleasedProperty()`
  Defines a function to be called when a new touch point is pressed.
  `final ObjectProperty<EventHandler<? super TouchEvent>>`
  `onTouchStationaryProperty()`
  Defines a function to be called when a touch point stays pressed and still.
  `final ObjectProperty<EventHandler<? super ZoomEvent>>`
  `onZoomFinishedProperty()`
  Defines a function to be called when a zooming gesture ends.
  `final ObjectProperty<EventHandler<? super ZoomEvent>>`
  `onZoomProperty()`
  Defines a function to be called when user performs a zooming action.
  `final ObjectProperty<EventHandler<? super ZoomEvent>>`
  `onZoomStartedProperty()`
  Defines a function to be called when a zooming gesture is detected.
  `final <T extends Event>
  void`
  `removeEventFilter(EventType<T> eventType, EventHandler<? super T> eventFilter)`
  Unregisters a previously registered event filter from this target.
  `final <T extends Event>
  void`
  `removeEventHandler(EventType<T> eventType, EventHandler<? super T> eventHandler)`
  Unregisters a previously registered event handler from this target.
  `void`
  `removeMnemonic(Mnemonic m)`
  Unregisters the specified mnemonic.
  `final void`
  `removePostLayoutPulseListener(Runnable r)`
  Removes a previously registered scene post layout pulse listener from listening to pulses in this scene.
  `final void`
  `removePreLayoutPulseListener(Runnable r)`
  Removes a previously registered scene pre layout pulse listener from listening to pulses in this scene.
  `final ObjectProperty<Parent>`
  `rootProperty()`
  Defines the root `Node` of the scene graph.
  `final void`
  `setCamera(Camera value)`
  Sets the value of the `camera` property.
  `final void`
  `setCursor(Cursor value)`
  Sets the value of the `cursor` property.
  `final void`
  `setEventDispatcher(EventDispatcher value)`
  Sets the value of the `eventDispatcher` property.
  `protected final <T extends Event>
  void`
  `setEventHandler(EventType<T> eventType, EventHandler<? super T> eventHandler)`
  Sets the handler to use for this event type.
  `final void`
  `setFill(Paint value)`
  Sets the value of the `fill` property.
  `final void`
  `setNodeOrientation(NodeOrientation orientation)`
  Sets the value of the `nodeOrientation` property.
  `final void`
  `setOnContextMenuRequested(EventHandler<? super ContextMenuEvent> value)`
  Sets the value of the `onContextMenuRequested` property.
  `final void`
  `setOnDragDetected(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onDragDetected` property.
  `final void`
  `setOnDragDone(EventHandler<? super DragEvent> value)`
  Sets the value of the `onDragDone` property.
  `final void`
  `setOnDragDropped(EventHandler<? super DragEvent> value)`
  Sets the value of the `onDragDropped` property.
  `final void`
  `setOnDragEntered(EventHandler<? super DragEvent> value)`
  Sets the value of the `onDragEntered` property.
  `final void`
  `setOnDragExited(EventHandler<? super DragEvent> value)`
  Sets the value of the `onDragExited` property.
  `final void`
  `setOnDragOver(EventHandler<? super DragEvent> value)`
  Sets the value of the `onDragOver` property.
  `final void`
  `setOnInputMethodTextChanged(EventHandler<? super InputMethodEvent> value)`
  Sets the value of the `onInputMethodTextChanged` property.
  `final void`
  `setOnKeyPressed(EventHandler<? super KeyEvent> value)`
  Sets the value of the `onKeyPressed` property.
  `final void`
  `setOnKeyReleased(EventHandler<? super KeyEvent> value)`
  Sets the value of the `onKeyReleased` property.
  `final void`
  `setOnKeyTyped(EventHandler<? super KeyEvent> value)`
  Sets the value of the `onKeyTyped` property.
  `final void`
  `setOnMouseClicked(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMouseClicked` property.
  `final void`
  `setOnMouseDragDone(EventHandler<? super MouseDragEvent> value)`
  Sets the value of the `onMouseDragDone` property.
  `final void`
  `setOnMouseDragEntered(EventHandler<? super MouseDragEvent> value)`
  Sets the value of the `onMouseDragEntered` property.
  `final void`
  `setOnMouseDragExited(EventHandler<? super MouseDragEvent> value)`
  Sets the value of the `onMouseDragExited` property.
  `final void`
  `setOnMouseDragged(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMouseDragged` property.
  `final void`
  `setOnMouseDragOver(EventHandler<? super MouseDragEvent> value)`
  Sets the value of the `onMouseDragOver` property.
  `final void`
  `setOnMouseDragReleased(EventHandler<? super MouseDragEvent> value)`
  Sets the value of the `onMouseDragReleased` property.
  `final void`
  `setOnMouseEntered(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMouseEntered` property.
  `final void`
  `setOnMouseExited(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMouseExited` property.
  `final void`
  `setOnMouseMoved(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMouseMoved` property.
  `final void`
  `setOnMousePressed(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMousePressed` property.
  `final void`
  `setOnMouseReleased(EventHandler<? super MouseEvent> value)`
  Sets the value of the `onMouseReleased` property.
  `final void`
  `setOnRotate(EventHandler<? super RotateEvent> value)`
  Sets the value of the `onRotate` property.
  `final void`
  `setOnRotationFinished(EventHandler<? super RotateEvent> value)`
  Sets the value of the `onRotationFinished` property.
  `final void`
  `setOnRotationStarted(EventHandler<? super RotateEvent> value)`
  Sets the value of the `onRotationStarted` property.
  `final void`
  `setOnScroll(EventHandler<? super ScrollEvent> value)`
  Sets the value of the `onScroll` property.
  `final void`
  `setOnScrollFinished(EventHandler<? super ScrollEvent> value)`
  Sets the value of the `onScrollFinished` property.
  `final void`
  `setOnScrollStarted(EventHandler<? super ScrollEvent> value)`
  Sets the value of the `onScrollStarted` property.
  `final void`
  `setOnSwipeDown(EventHandler<? super SwipeEvent> value)`
  Sets the value of the `onSwipeDown` property.
  `final void`
  `setOnSwipeLeft(EventHandler<? super SwipeEvent> value)`
  Sets the value of the `onSwipeLeft` property.
  `final void`
  `setOnSwipeRight(EventHandler<? super SwipeEvent> value)`
  Sets the value of the `onSwipeRight` property.
  `final void`
  `setOnSwipeUp(EventHandler<? super SwipeEvent> value)`
  Sets the value of the `onSwipeUp` property.
  `final void`
  `setOnTouchMoved(EventHandler<? super TouchEvent> value)`
  Sets the value of the `onTouchMoved` property.
  `final void`
  `setOnTouchPressed(EventHandler<? super TouchEvent> value)`
  Sets the value of the `onTouchPressed` property.
  `final void`
  `setOnTouchReleased(EventHandler<? super TouchEvent> value)`
  Sets the value of the `onTouchReleased` property.
  `final void`
  `setOnTouchStationary(EventHandler<? super TouchEvent> value)`
  Sets the value of the `onTouchStationary` property.
  `final void`
  `setOnZoom(EventHandler<? super ZoomEvent> value)`
  Sets the value of the `onZoom` property.
  `final void`
  `setOnZoomFinished(EventHandler<? super ZoomEvent> value)`
  Sets the value of the `onZoomFinished` property.
  `final void`
  `setOnZoomStarted(EventHandler<? super ZoomEvent> value)`
  Sets the value of the `onZoomStarted` property.
  `final void`
  `setRoot(Parent value)`
  Sets the value of the `root` property.
  `final void`
  `setUserAgentStylesheet(String url)`
  Set the URL of the user-agent stylesheet that will be used by this Scene in place of the the platform-default user-agent stylesheet.
  `void`
  `setUserData(Object value)`
  Convenience method for setting a single Object property that can be retrieved at a later date.
  `WritableImage`
  `snapshot(WritableImage image)`
  Takes a snapshot of this scene and returns the rendered image when it is ready.
  `void`
  `snapshot(Callback<SnapshotResult, Void> callback, WritableImage image)`
  Takes a snapshot of this scene at the next frame and calls the specified callback method when the image is ready.
  `Dragboard`
  `startDragAndDrop(TransferMode... transferModes)`
  Confirms a potential drag and drop gesture that is recognized over this `Scene`.
  `void`
  `startFullDrag()`
  Starts a full press-drag-release gesture with this scene as gesture source.
  `final ObjectProperty<String>`
  `userAgentStylesheetProperty()`
  Gets the userAgentStylesheet property.
  `final ReadOnlyDoubleProperty`
  `widthProperty()`
  The width of this `Scene`
  `final ReadOnlyObjectProperty<Window>`
  `windowProperty()`
  The `Window` for this `Scene`
  `final ReadOnlyDoubleProperty`
  `xProperty()`
  The horizontal location of this `Scene` on the `Window`.
  `final ReadOnlyDoubleProperty`
  `yProperty()`
  The vertical location of this `Scene` on the `Window`.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Property Details

  - ### window

    public final ReadOnlyObjectProperty<Window> windowProperty
    The `Window` for this `Scene`
    See Also:
      - `getWindow()`
      - `windowProperty()`

  - ### x

    public final ReadOnlyDoubleProperty xProperty
    The horizontal location of this `Scene` on the `Window`.
    See Also:
      - `getX()`
      - `xProperty()`

  - ### y

    public final ReadOnlyDoubleProperty yProperty
    The vertical location of this `Scene` on the `Window`.
    See Also:
      - `getY()`
      - `yProperty()`

  - ### width

    public final ReadOnlyDoubleProperty widthProperty
    The width of this `Scene`
    See Also:
      - `getWidth()`
      - `widthProperty()`

  - ### height

    public final ReadOnlyDoubleProperty heightProperty
    The height of this `Scene`
    See Also:
      - `getHeight()`
      - `heightProperty()`

  - ### camera

    public final ObjectProperty<Camera> cameraProperty
    Specifies the type of camera use for rendering this `Scene`. If `camera` is null, a parallel camera is used for rendering. It is illegal to set a camera that belongs to other `Scene` or `SubScene`.

    Note: this is a conditional feature. See `ConditionalFeature.SCENE3D` for more information.

    Default value:
      null
    See Also:
      - `getCamera()`
      - `setCamera(Camera)`
      - `cameraProperty()`

  - ### fill

    public final ObjectProperty<Paint> fillProperty
    Defines the background fill of this `Scene`. Both a `null` value meaning 'paint no background' and a `Paint` with transparency are supported. The default fill of the Scene is `Color.WHITE`, but it is more commonly the case that the initial color shown to users is the background fill of the `root node` of the `Scene`, as it typically is stretched to take up all available space in the `Scene`. The root node of the `Scene` is given the CSS style class 'root', and the default user agent stylesheets that ship with JavaFX (presently Caspian and Modena) apply styling on to this root style class. In the case of Caspian this does not impact the background fill color of the root node, but in the case of Modena the default fill is set to be a light gray color.
    Default value:
      WHITE
    See Also:
      - `getFill()`
      - `setFill(Paint)`
      - `fillProperty()`

  - ### root

    public final ObjectProperty<Parent> rootProperty
    Defines the root `Node` of the scene graph. If a `Group` is used as the root, the contents of the scene graph will be clipped by the scene's width and height and changes to the scene's size (if user resizes the stage) will not alter the layout of the scene graph. If a resizable node (layout `Region` or `Control`) is set as the root, then the root's size will track the scene's size, causing the contents to be relayed out as necessary.

    The `:root` pseudo-class matches the root node.

    Scene doesn't accept null root.

    See Also:
      - `getRoot()`
      - `setRoot(Parent)`
      - `rootProperty()`

  - ### cursor

    public final ObjectProperty<Cursor> cursorProperty
    Defines the mouse cursor for this `Scene`.
    See Also:
      - `getCursor()`
      - `setCursor(Cursor)`
      - `cursorProperty()`

  - ### userAgentStylesheet

    public final ObjectProperty<String> userAgentStylesheetProperty
    Gets the userAgentStylesheet property.
    Since:
      JavaFX 8u20
    See Also:
      - `getUserAgentStylesheet()`
      - `setUserAgentStylesheet(String)`
      - `userAgentStylesheetProperty()`

  - ### focusOwner

    public final ReadOnlyObjectProperty<Node> focusOwnerProperty
    The scene's current focus owner node. This node's "focused" variable might be false if this scene has no window, or if the window is inactive (window.focused == false).
    Since:
      JavaFX 2.2
    See Also:
      - `getFocusOwner()`
      - `focusOwnerProperty()`

  - ### eventDispatcher

    public final ObjectProperty<EventDispatcher> eventDispatcherProperty
    Specifies the event dispatcher for this scene. When replacing the value with a new `EventDispatcher`, the new dispatcher should forward events to the replaced dispatcher to keep the scene's default event handling behavior.
    See Also:
      - `getEventDispatcher()`
      - `setEventDispatcher(EventDispatcher)`
      - `eventDispatcherProperty()`

  - ### onContextMenuRequested

    public final ObjectProperty<EventHandler<? super ContextMenuEvent>> onContextMenuRequestedProperty
    Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Since:
      JavaFX 2.1
    See Also:
      - `getOnContextMenuRequested()`
      - `setOnContextMenuRequested(EventHandler)`
      - `onContextMenuRequestedProperty()`

  - ### onMouseClicked

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseClickedProperty
    Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    See Also:
      - `getOnMouseClicked()`
      - `setOnMouseClicked(EventHandler)`
      - `onMouseClickedProperty()`

  - ### onMouseDragged

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseDraggedProperty
    Defines a function to be called when a mouse button is pressed on this `Scene` and then dragged.
    See Also:
      - `getOnMouseDragged()`
      - `setOnMouseDragged(EventHandler)`
      - `onMouseDraggedProperty()`

  - ### onMouseEntered

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseEnteredProperty
    Defines a function to be called when the mouse enters this `Scene`.
    See Also:
      - `getOnMouseEntered()`
      - `setOnMouseEntered(EventHandler)`
      - `onMouseEnteredProperty()`

  - ### onMouseExited

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseExitedProperty
    Defines a function to be called when the mouse exits this `Scene`.
    See Also:
      - `getOnMouseExited()`
      - `setOnMouseExited(EventHandler)`
      - `onMouseExitedProperty()`

  - ### onMouseMoved

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseMovedProperty
    Defines a function to be called when mouse cursor moves within this `Scene` but no buttons have been pushed.
    See Also:
      - `getOnMouseMoved()`
      - `setOnMouseMoved(EventHandler)`
      - `onMouseMovedProperty()`

  - ### onMousePressed

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMousePressedProperty
    Defines a function to be called when a mouse button has been pressed on this `Scene`.
    See Also:
      - `getOnMousePressed()`
      - `setOnMousePressed(EventHandler)`
      - `onMousePressedProperty()`

  - ### onMouseReleased

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseReleasedProperty
    Defines a function to be called when a mouse button has been released on this `Scene`.
    See Also:
      - `getOnMouseReleased()`
      - `setOnMouseReleased(EventHandler)`
      - `onMouseReleasedProperty()`

  - ### onDragDetected

    public final ObjectProperty<EventHandler<? super MouseEvent>> onDragDetectedProperty
    Defines a function to be called when drag gesture has been detected. This is the right place to start drag and drop operation.
    See Also:
      - `getOnDragDetected()`
      - `setOnDragDetected(EventHandler)`
      - `onDragDetectedProperty()`

  - ### onMouseDragOver

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragOverProperty
    Defines a function to be called when a full press-drag-release gesture progresses within this `Scene`.
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragOver()`
      - `setOnMouseDragOver(EventHandler)`
      - `onMouseDragOverProperty()`

  - ### onMouseDragReleased

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragReleasedProperty
    Defines a function to be called when a full press-drag-release gesture ends within this `Scene`.
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragReleased()`
      - `setOnMouseDragReleased(EventHandler)`
      - `onMouseDragReleasedProperty()`

  - ### onMouseDragEntered

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragEnteredProperty
    Defines a function to be called when a full press-drag-release gesture enters this `Scene`.
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragEntered()`
      - `setOnMouseDragEntered(EventHandler)`
      - `onMouseDragEnteredProperty()`

  - ### onMouseDragExited

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragExitedProperty
    Defines a function to be called when a full press-drag-release gesture exits this `Scene`.
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragExited()`
      - `setOnMouseDragExited(EventHandler)`
      - `onMouseDragExitedProperty()`

  - ### onMouseDragDone

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragDoneProperty
    Defines a function to be called when a full press-drag-release gesture ends.
    Since:
      26
    See Also:
      - `getOnMouseDragDone()`
      - `setOnMouseDragDone(EventHandler)`
      - `onMouseDragDoneProperty()`

  - ### onScrollStarted

    public final ObjectProperty<EventHandler<? super ScrollEvent>> onScrollStartedProperty
    Defines a function to be called when a scrolling gesture is detected.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnScrollStarted()`
      - `setOnScrollStarted(EventHandler)`
      - `onScrollStartedProperty()`

  - ### onScroll

    public final ObjectProperty<EventHandler<? super ScrollEvent>> onScrollProperty
    Defines a function to be called when user performs a scrolling action.
    See Also:
      - `getOnScroll()`
      - `setOnScroll(EventHandler)`
      - `onScrollProperty()`

  - ### onScrollFinished

    public final ObjectProperty<EventHandler<? super ScrollEvent>> onScrollFinishedProperty
    Defines a function to be called when a scrolling gesture ends.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnScrollFinished()`
      - `setOnScrollFinished(EventHandler)`
      - `onScrollFinishedProperty()`

  - ### onRotationStarted

    public final ObjectProperty<EventHandler<? super RotateEvent>> onRotationStartedProperty
    Defines a function to be called when a rotating gesture is detected.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotationStarted()`
      - `setOnRotationStarted(EventHandler)`
      - `onRotationStartedProperty()`

  - ### onRotate

    public final ObjectProperty<EventHandler<? super RotateEvent>> onRotateProperty
    Defines a function to be called when user performs a rotating action.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotate()`
      - `setOnRotate(EventHandler)`
      - `onRotateProperty()`

  - ### onRotationFinished

    public final ObjectProperty<EventHandler<? super RotateEvent>> onRotationFinishedProperty
    Defines a function to be called when a rotating gesture ends.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotationFinished()`
      - `setOnRotationFinished(EventHandler)`
      - `onRotationFinishedProperty()`

  - ### onZoomStarted

    public final ObjectProperty<EventHandler<? super ZoomEvent>> onZoomStartedProperty
    Defines a function to be called when a zooming gesture is detected.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoomStarted()`
      - `setOnZoomStarted(EventHandler)`
      - `onZoomStartedProperty()`

  - ### onZoom

    public final ObjectProperty<EventHandler<? super ZoomEvent>> onZoomProperty
    Defines a function to be called when user performs a zooming action.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoom()`
      - `setOnZoom(EventHandler)`
      - `onZoomProperty()`

  - ### onZoomFinished

    public final ObjectProperty<EventHandler<? super ZoomEvent>> onZoomFinishedProperty
    Defines a function to be called when a zooming gesture ends.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoomFinished()`
      - `setOnZoomFinished(EventHandler)`
      - `onZoomFinishedProperty()`

  - ### onSwipeUp

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeUpProperty
    Defines a function to be called when an upward swipe gesture happens in this scene.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeUp()`
      - `setOnSwipeUp(EventHandler)`
      - `onSwipeUpProperty()`

  - ### onSwipeDown

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeDownProperty
    Defines a function to be called when an downward swipe gesture happens in this scene.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeDown()`
      - `setOnSwipeDown(EventHandler)`
      - `onSwipeDownProperty()`

  - ### onSwipeLeft

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeLeftProperty
    Defines a function to be called when an leftward swipe gesture happens in this scene.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeLeft()`
      - `setOnSwipeLeft(EventHandler)`
      - `onSwipeLeftProperty()`

  - ### onSwipeRight

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeRightProperty
    Defines a function to be called when an rightward swipe gesture happens in this scene.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeRight()`
      - `setOnSwipeRight(EventHandler)`
      - `onSwipeRightProperty()`

  - ### onTouchPressed

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchPressedProperty
    Defines a function to be called when a new touch point is pressed.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchPressed()`
      - `setOnTouchPressed(EventHandler)`
      - `onTouchPressedProperty()`

  - ### onTouchMoved

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchMovedProperty
    Defines a function to be called when a touch point is moved.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchMoved()`
      - `setOnTouchMoved(EventHandler)`
      - `onTouchMovedProperty()`

  - ### onTouchReleased

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchReleasedProperty
    Defines a function to be called when a new touch point is pressed.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchReleased()`
      - `setOnTouchReleased(EventHandler)`
      - `onTouchReleasedProperty()`

  - ### onTouchStationary

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchStationaryProperty
    Defines a function to be called when a touch point stays pressed and still.
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchStationary()`
      - `setOnTouchStationary(EventHandler)`
      - `onTouchStationaryProperty()`

  - ### onDragEntered

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragEnteredProperty
    Defines a function to be called when drag gesture enters this `Scene`.
    See Also:
      - `getOnDragEntered()`
      - `setOnDragEntered(EventHandler)`
      - `onDragEnteredProperty()`

  - ### onDragExited

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragExitedProperty
    Defines a function to be called when drag gesture exits this `Scene`.
    See Also:
      - `getOnDragExited()`
      - `setOnDragExited(EventHandler)`
      - `onDragExitedProperty()`

  - ### onDragOver

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragOverProperty
    Defines a function to be called when drag gesture progresses within this `Scene`.
    See Also:
      - `getOnDragOver()`
      - `setOnDragOver(EventHandler)`
      - `onDragOverProperty()`

  - ### onDragDropped

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragDroppedProperty
    Defines a function to be called when the mouse button is released on this `Scene` during drag and drop gesture. Transfer of data from the `DragEvent`'s `dragboard` should happen in this function.
    See Also:
      - `getOnDragDropped()`
      - `setOnDragDropped(EventHandler)`
      - `onDragDroppedProperty()`

  - ### onDragDone

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragDoneProperty
    Defines a function to be called when this `Scene` is a drag and drop gesture source after its data has been dropped on a drop target. The `transferMode` of the event shows what just happened at the drop target. If `transferMode` has the value `MOVE`, then the source can clear out its data. Clearing the source's data gives the appropriate appearance to a user that the data has been moved by the drag and drop gesture. A `transferMode` that has the value `NONE` indicates that no data was transferred during the drag and drop gesture. Positional data for the `DragEvent` is invalid. Valid positional data for the `DragEvent` is presented in the `onDragDropped` event handler.
    See Also:
      - `getOnDragDone()`
      - `setOnDragDone(EventHandler)`
      - `onDragDoneProperty()`

  - ### onKeyPressed

    public final ObjectProperty<EventHandler<? super KeyEvent>> onKeyPressedProperty
    Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been pressed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    See Also:
      - `getOnKeyPressed()`
      - `setOnKeyPressed(EventHandler)`
      - `onKeyPressedProperty()`

  - ### onKeyReleased

    public final ObjectProperty<EventHandler<? super KeyEvent>> onKeyReleasedProperty
    Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been released. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    See Also:
      - `getOnKeyReleased()`
      - `setOnKeyReleased(EventHandler)`
      - `onKeyReleasedProperty()`

  - ### onKeyTyped

    public final ObjectProperty<EventHandler<? super KeyEvent>> onKeyTypedProperty
    Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been typed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    See Also:
      - `getOnKeyTyped()`
      - `setOnKeyTyped(EventHandler)`
      - `onKeyTypedProperty()`

  - ### onInputMethodTextChanged

    public final ObjectProperty<EventHandler<? super InputMethodEvent>> onInputMethodTextChangedProperty
    Defines a function to be called when this `Node` has input focus and the input method text has changed. If this function is not defined in this `Node`, then it receives the result string of the input method composition as a series of `onKeyTyped` function calls.

    When the `Node` loses the input focus, the JavaFX runtime automatically commits the existing composed text if any.

    See Also:
      - `getOnInputMethodTextChanged()`
      - `setOnInputMethodTextChanged(EventHandler)`
      - `onInputMethodTextChangedProperty()`

  - ### nodeOrientation

    public final ObjectProperty<NodeOrientation> nodeOrientationProperty
    Node orientation describes the flow of visual data within a node. In the English speaking world, visual data normally flows from left-to-right. In an Arabic or Hebrew world, visual data flows from right-to-left. This is consistent with the reading order of text in both worlds.
    Default value:
      if the system property `javafx.scene.nodeOrientation.RTL` is `true`, `NodeOrientation.RIGHT_TO_LEFT`, otherwise `NodeOrientation.INHERIT`
    Since:
      JavaFX 8.0
    See Also:
      - `getNodeOrientation()`
      - `setNodeOrientation(NodeOrientation)`
      - `nodeOrientationProperty()`

  - ### effectiveNodeOrientation

    public final ReadOnlyObjectProperty<NodeOrientation> effectiveNodeOrientationProperty
    The effective node orientation of a scene resolves the inheritance of node orientation, returning either left-to-right or right-to-left.
    Since:
      JavaFX 8.0
    See Also:
      - `getEffectiveNodeOrientation()`
      - `effectiveNodeOrientationProperty()`

- ## Constructor Details

  - ### Scene

    public Scene(Parent root)
    Creates a Scene for a specific root Node.
    Parameters:
      `root` - The root node of the scene graph
    Throws:
      `NullPointerException` - if root is null

  - ### Scene

    public Scene(Parent root, double width, double height)
    Creates a Scene for a specific root Node with a specific size.
    Parameters:
      `root` - The root node of the scene graph
      `width` - The width of the scene
      `height` - The height of the scene
    Throws:
      `NullPointerException` - if root is null

  - ### Scene

    public Scene(Parent root, Paint fill)
    Creates a Scene for a specific root Node with a fill.
    Parameters:
      `root` - The parent
      `fill` - The fill
    Throws:
      `NullPointerException` - if root is null

  - ### Scene

    public Scene(Parent root, double width, double height, Paint fill)
    Creates a Scene for a specific root Node with a specific size and fill.
    Parameters:
      `root` - The root node of the scene graph
      `width` - The width of the scene
      `height` - The height of the scene
      `fill` - The fill
    Throws:
      `NullPointerException` - if root is null

  - ### Scene

    public Scene(Parent root, double width, double height, boolean depthBuffer)
    Constructs a scene consisting of a root, with a dimension of width and height, and specifies whether a depth buffer is created for this scene.

    A scene with only 2D shapes and without any 3D transforms does not need a depth buffer. A scene containing 3D shapes or 2D shapes with 3D transforms may use depth buffer support for proper depth sorted rendering; to avoid depth fighting (also known as Z fighting), disable depth testing on 2D shapes that have no 3D transforms. See `depthTest` for more information.

    Parameters:
      `root` - The root node of the scene graph
      `width` - The width of the scene
      `height` - The height of the scene
      `depthBuffer` - The depth buffer flag

      The depthBuffer flag is a conditional feature and its default value is false. See `ConditionalFeature.SCENE3D` for more information.

    Throws:
      `NullPointerException` - if root is null
    See Also:
      - `Node.setDepthTest(DepthTest)`

  - ### Scene

    public Scene(Parent root, double width, double height, boolean depthBuffer, SceneAntialiasing antiAliasing)
    Constructs a scene consisting of a root, with a dimension of width and height, specifies whether a depth buffer is created for this scene and specifies whether scene anti-aliasing is requested.

    A scene with only 2D shapes and without any 3D transforms does not need a depth buffer nor scene anti-aliasing support. A scene containing 3D shapes or 2D shapes with 3D transforms may use depth buffer support for proper depth sorted rendering; to avoid depth fighting (also known as Z fighting), disable depth testing on 2D shapes that have no 3D transforms. See `depthTest` for more information. A scene with 3D shapes may enable scene anti-aliasing to improve its rendering quality.

    Parameters:
      `root` - The root node of the scene graph
      `width` - The width of the scene
      `height` - The height of the scene
      `depthBuffer` - The depth buffer flag
      `antiAliasing` - The scene anti-aliasing attribute. A value of `null` is treated as DISABLED.

      The depthBuffer and antiAliasing are conditional features. With the respective default values of: false and `SceneAntialiasing.DISABLED`. See `ConditionalFeature.SCENE3D` for more information.

    Throws:
      `NullPointerException` - if root is null
    Since:
      JavaFX 8.0
    See Also:
      - `Node.setDepthTest(DepthTest)`

- ## Method Details

  - ### addPreLayoutPulseListener

    public final void addPreLayoutPulseListener(Runnable r)
    Adds a new scene pre layout pulse listener to this scene. Every time a pulse occurs, this listener will be called on the JavaFX Application Thread directly before the CSS and layout passes, and also before any rendering is done for this frame. This scene pulse listener is suitable for knowing when a scenegraph pulse is happening and also for modifying the scenegraph (as it is called before CSS and layout, so any changes made will be properly styled and positioned). This method must be called on the JavaFX Application thread.
    Parameters:
      `r` - The Runnable to be called when the pulse occurs.
    Throws:
      `IllegalStateException` - if this method is called on a thread other than the JavaFX Application Thread.
      `NullPointerException` - if the provided Runnable is null.
    Since:
      9

  - ### removePreLayoutPulseListener

    public final void removePreLayoutPulseListener(Runnable r)
    Removes a previously registered scene pre layout pulse listener from listening to pulses in this scene. This method does nothing if the specified Runnable is not already in the list. This method must be called on the JavaFX Application thread.
    Parameters:
      `r` - The Runnable that should no longer be called when the pulse occurs for this scene.
    Throws:
      `IllegalStateException` - if this method is called on a thread other than the JavaFX Application Thread.
    Since:
      9

  - ### addPostLayoutPulseListener

    public final void addPostLayoutPulseListener(Runnable r)
    Adds a new scene post layout pulse listener to this scene. Every time a pulse occurs, this listener will be called on the JavaFX Application Thread directly after the CSS and layout passes, but before any rendering is done for this frame. This scene pulse listener is suitable for knowing when a scenegraph pulse is happening, but it is not suited to use cases related to modifying the scenegraph (as it is called after CSS and layout, so any changes will possibly be incorrect until the next pulse is run). An alternative (and better) solution for situations where a scenegraph modification is required to happen is to use either the `addPreLayoutPulseListener(Runnable)` API or the the `AnimationTimer` API. This method must be called on the JavaFX Application thread.
    Parameters:
      `r` - The Runnable to be called when the pulse occurs.
    Throws:
      `IllegalStateException` - if this method is called on a thread other than the JavaFX Application Thread.
      `NullPointerException` - if the provided Runnable is null.
    Since:
      9

  - ### removePostLayoutPulseListener

    public final void removePostLayoutPulseListener(Runnable r)
    Removes a previously registered scene post layout pulse listener from listening to pulses in this scene. This method does nothing if the specified Runnable is not already in the list. This method must be called on the JavaFX Application thread.
    Parameters:
      `r` - The Runnable that should no longer be called when the pulse occurs for this scene.
    Throws:
      `IllegalStateException` - if this method is called on a thread other than the JavaFX Application Thread.
    Since:
      9

  - ### getAntiAliasing

    public final SceneAntialiasing getAntiAliasing()
    Return the defined `SceneAntialiasing` for this `Scene`.

    Note: this is a conditional feature. See `ConditionalFeature.SCENE3D` and `SceneAntialiasing` for more information.

    Returns:
      the SceneAntialiasing for this scene
    Since:
      JavaFX 8.0

  - ### getWindow

    public final Window getWindow()
    Gets the value of the `window` property.
    Property description:
      The `Window` for this `Scene`
    Returns:
      the value of the `window` property
    See Also:
      - `windowProperty()`

  - ### windowProperty

    public final ReadOnlyObjectProperty<Window> windowProperty()
    The `Window` for this `Scene`
    Returns:
      the `window` property
    See Also:
      - `getWindow()`

  - ### getX

    public final double getX()
    Gets the value of the `x` property.
    Property description:
      The horizontal location of this `Scene` on the `Window`.
    Returns:
      the value of the `x` property
    See Also:
      - `xProperty()`

  - ### xProperty

    public final ReadOnlyDoubleProperty xProperty()
    The horizontal location of this `Scene` on the `Window`.
    Returns:
      the `x` property
    See Also:
      - `getX()`

  - ### getY

    public final double getY()
    Gets the value of the `y` property.
    Property description:
      The vertical location of this `Scene` on the `Window`.
    Returns:
      the value of the `y` property
    See Also:
      - `yProperty()`

  - ### yProperty

    public final ReadOnlyDoubleProperty yProperty()
    The vertical location of this `Scene` on the `Window`.
    Returns:
      the `y` property
    See Also:
      - `getY()`

  - ### getWidth

    public final double getWidth()
    Gets the value of the `width` property.
    Property description:
      The width of this `Scene`
    Returns:
      the value of the `width` property
    See Also:
      - `widthProperty()`

  - ### widthProperty

    public final ReadOnlyDoubleProperty widthProperty()
    The width of this `Scene`
    Returns:
      the `width` property
    See Also:
      - `getWidth()`

  - ### getHeight

    public final double getHeight()
    Gets the value of the `height` property.
    Property description:
      The height of this `Scene`
    Returns:
      the value of the `height` property
    See Also:
      - `heightProperty()`

  - ### heightProperty

    public final ReadOnlyDoubleProperty heightProperty()
    The height of this `Scene`
    Returns:
      the `height` property
    See Also:
      - `getHeight()`

  - ### setCamera

    public final void setCamera(Camera value)
    Sets the value of the `camera` property.
    Property description:
      Specifies the type of camera use for rendering this `Scene`. If `camera` is null, a parallel camera is used for rendering. It is illegal to set a camera that belongs to other `Scene` or `SubScene`.

      Note: this is a conditional feature. See `ConditionalFeature.SCENE3D` for more information.

    Default value:
      null
    Parameters:
      `value` - the value for the `camera` property
    See Also:
      - `getCamera()`
      - `cameraProperty()`

  - ### getCamera

    public final Camera getCamera()
    Gets the value of the `camera` property.
    Property description:
      Specifies the type of camera use for rendering this `Scene`. If `camera` is null, a parallel camera is used for rendering. It is illegal to set a camera that belongs to other `Scene` or `SubScene`.

      Note: this is a conditional feature. See `ConditionalFeature.SCENE3D` for more information.

    Default value:
      null
    Returns:
      the value of the `camera` property
    See Also:
      - `setCamera(Camera)`
      - `cameraProperty()`

  - ### cameraProperty

    public final ObjectProperty<Camera> cameraProperty()
    Specifies the type of camera use for rendering this `Scene`. If `camera` is null, a parallel camera is used for rendering. It is illegal to set a camera that belongs to other `Scene` or `SubScene`.

    Note: this is a conditional feature. See `ConditionalFeature.SCENE3D` for more information.

    Default value:
      null
    Returns:
      the `camera` property
    See Also:
      - `getCamera()`
      - `setCamera(Camera)`

  - ### setFill

    public final void setFill(Paint value)
    Sets the value of the `fill` property.
    Property description:
      Defines the background fill of this `Scene`. Both a `null` value meaning 'paint no background' and a `Paint` with transparency are supported. The default fill of the Scene is `Color.WHITE`, but it is more commonly the case that the initial color shown to users is the background fill of the `root node` of the `Scene`, as it typically is stretched to take up all available space in the `Scene`. The root node of the `Scene` is given the CSS style class 'root', and the default user agent stylesheets that ship with JavaFX (presently Caspian and Modena) apply styling on to this root style class. In the case of Caspian this does not impact the background fill color of the root node, but in the case of Modena the default fill is set to be a light gray color.
    Default value:
      WHITE
    Parameters:
      `value` - the value for the `fill` property
    See Also:
      - `getFill()`
      - `fillProperty()`

  - ### getFill

    public final Paint getFill()
    Gets the value of the `fill` property.
    Property description:
      Defines the background fill of this `Scene`. Both a `null` value meaning 'paint no background' and a `Paint` with transparency are supported. The default fill of the Scene is `Color.WHITE`, but it is more commonly the case that the initial color shown to users is the background fill of the `root node` of the `Scene`, as it typically is stretched to take up all available space in the `Scene`. The root node of the `Scene` is given the CSS style class 'root', and the default user agent stylesheets that ship with JavaFX (presently Caspian and Modena) apply styling on to this root style class. In the case of Caspian this does not impact the background fill color of the root node, but in the case of Modena the default fill is set to be a light gray color.
    Default value:
      WHITE
    Returns:
      the value of the `fill` property
    See Also:
      - `setFill(Paint)`
      - `fillProperty()`

  - ### fillProperty

    public final ObjectProperty<Paint> fillProperty()
    Defines the background fill of this `Scene`. Both a `null` value meaning 'paint no background' and a `Paint` with transparency are supported. The default fill of the Scene is `Color.WHITE`, but it is more commonly the case that the initial color shown to users is the background fill of the `root node` of the `Scene`, as it typically is stretched to take up all available space in the `Scene`. The root node of the `Scene` is given the CSS style class 'root', and the default user agent stylesheets that ship with JavaFX (presently Caspian and Modena) apply styling on to this root style class. In the case of Caspian this does not impact the background fill color of the root node, but in the case of Modena the default fill is set to be a light gray color.
    Default value:
      WHITE
    Returns:
      the `fill` property
    See Also:
      - `getFill()`
      - `setFill(Paint)`

  - ### setRoot

    public final void setRoot(Parent value)
    Sets the value of the `root` property.
    Property description:
      Defines the root `Node` of the scene graph. If a `Group` is used as the root, the contents of the scene graph will be clipped by the scene's width and height and changes to the scene's size (if user resizes the stage) will not alter the layout of the scene graph. If a resizable node (layout `Region` or `Control`) is set as the root, then the root's size will track the scene's size, causing the contents to be relayed out as necessary.

      The `:root` pseudo-class matches the root node.

      Scene doesn't accept null root.

    Parameters:
      `value` - the value for the `root` property
    See Also:
      - `getRoot()`
      - `rootProperty()`

  - ### getRoot

    public final Parent getRoot()
    Gets the value of the `root` property.
    Property description:
      Defines the root `Node` of the scene graph. If a `Group` is used as the root, the contents of the scene graph will be clipped by the scene's width and height and changes to the scene's size (if user resizes the stage) will not alter the layout of the scene graph. If a resizable node (layout `Region` or `Control`) is set as the root, then the root's size will track the scene's size, causing the contents to be relayed out as necessary.

      The `:root` pseudo-class matches the root node.

      Scene doesn't accept null root.

    Returns:
      the value of the `root` property
    See Also:
      - `setRoot(Parent)`
      - `rootProperty()`

  - ### rootProperty

    public final ObjectProperty<Parent> rootProperty()
    Defines the root `Node` of the scene graph. If a `Group` is used as the root, the contents of the scene graph will be clipped by the scene's width and height and changes to the scene's size (if user resizes the stage) will not alter the layout of the scene graph. If a resizable node (layout `Region` or `Control`) is set as the root, then the root's size will track the scene's size, causing the contents to be relayed out as necessary.

    The `:root` pseudo-class matches the root node.

    Scene doesn't accept null root.

    Returns:
      the `root` property
    See Also:
      - `getRoot()`
      - `setRoot(Parent)`

  - ### snapshot

    public WritableImage snapshot(WritableImage image)
    Takes a snapshot of this scene and returns the rendered image when it is ready. CSS and layout processing will be done for the scene prior to rendering it. The entire destination image is cleared using the fill `Paint` of this scene. The nodes in the scene are then rendered to the image. The point (0,0) in scene coordinates is mapped to (0,0) in the image. If the image is smaller than the size of the scene, then the rendering will be clipped by the image.

    When taking a snapshot of a scene that is being animated, either explicitly by the application or implicitly (such as chart animation), the snapshot will be rendered based on the state of the scene graph at the moment the snapshot is taken and will not reflect any subsequent animation changes.

    Parameters:
      `image` - the writable image that will be used to hold the rendered scene. It may be null in which case a new WritableImage will be constructed. If the image is non-null, the scene will be rendered into the existing image. In this case, the width and height of the image determine the area that is rendered instead of the width and height of the scene.
    Returns:
      the rendered image
    Throws:
      `IllegalStateException` - if this method is called on a thread other than the JavaFX Application Thread.
    Since:
      JavaFX 2.2

  - ### snapshot

    public void snapshot(Callback<SnapshotResult, Void> callback, WritableImage image)
    Takes a snapshot of this scene at the next frame and calls the specified callback method when the image is ready. CSS and layout processing will be done for the scene prior to rendering it. The entire destination image is cleared using the fill `Paint` of this scene. The nodes in the scene are then rendered to the image. The point (0,0) in scene coordinates is mapped to (0,0) in the image. If the image is smaller than the size of the scene, then the rendering will be clipped by the image.

    This is an asynchronous call, which means that other events or animation might be processed before the scene is rendered. If any such events modify a node in the scene that modification will be reflected in the rendered image (as it will also be reflected in the frame rendered to the Stage).

    When taking a snapshot of a scene that is being animated, either explicitly by the application or implicitly (such as chart animation), the snapshot will be rendered based on the state of the scene graph at the moment the snapshot is taken and will not reflect any subsequent animation changes.

    Parameters:
      `callback` - a class whose call method will be called when the image is ready. The SnapshotResult that is passed into the call method of the callback will contain the rendered image and the source scene that was rendered. The callback parameter must not be null.
      `image` - the writable image that will be used to hold the rendered scene. It may be null in which case a new WritableImage will be constructed. If the image is non-null, the scene will be rendered into the existing image. In this case, the width and height of the image determine the area that is rendered instead of the width and height of the scene.
    Throws:
      `IllegalStateException` - if this method is called on a thread other than the JavaFX Application Thread.
      `NullPointerException` - if the callback parameter is null.
    Since:
      JavaFX 2.2

  - ### setCursor

    public final void setCursor(Cursor value)
    Sets the value of the `cursor` property.
    Property description:
      Defines the mouse cursor for this `Scene`.
    Parameters:
      `value` - the value for the `cursor` property
    See Also:
      - `getCursor()`
      - `cursorProperty()`

  - ### getCursor

    public final Cursor getCursor()
    Gets the value of the `cursor` property.
    Property description:
      Defines the mouse cursor for this `Scene`.
    Returns:
      the value of the `cursor` property
    See Also:
      - `setCursor(Cursor)`
      - `cursorProperty()`

  - ### cursorProperty

    public final ObjectProperty<Cursor> cursorProperty()
    Defines the mouse cursor for this `Scene`.
    Returns:
      the `cursor` property
    See Also:
      - `getCursor()`
      - `setCursor(Cursor)`

  - ### lookup

    public Node lookup(String selector)
    Looks for any node within the scene graph based on the specified CSS selector. If more than one node matches the specified selector, this function returns the first of them. If no nodes are found with this id, then null is returned.
    Parameters:
      `selector` - The css selector to look up
    Returns:
      the `Node` in the scene which matches the CSS `selector`, or `null` if none is found.

  - ### getStylesheets

    public final ObservableList<String> getStylesheets()
    Gets an observable list of string URLs linking to the stylesheets to use with this scene's contents.

    The URL is a hierarchical URI of the form [scheme:][//authority][path]. If the URL does not have a [scheme:] component, the URL is considered to be the [path] component only. Any leading '/' character of the [path] is ignored and the [path] is treated as a path relative to the root of the application's classpath.

    The RFC 2397 "data" scheme for URLs is supported in addition to the protocol handlers that are registered for the application. If a URL uses the "data" scheme and the MIME type is either empty, "text/plain", or "text/css", the payload will be interpreted as a CSS file. If the MIME type is "application/octet-stream", the payload will be interpreted as a binary CSS file (see `Stylesheet.convertToBinary(File, File)`).

        package com.example.javafx.app;

        import javafx.application.Application;
        import javafx.scene.Group;
        import javafx.scene.Scene;
        import javafx.stage.Stage;

        public class MyApp extends Application {

            @Override public void start(Stage stage) {
                Scene scene = new Scene(new Group());
                scene.getStylesheets().add("/com/example/javafx/app/mystyles.css");
                stage.setScene(scene);
                stage.show();
            }

            public static void main(String[] args) {
                launch(args);
            }
        }

    For additional information about using CSS with the scene graph, see the CSS Reference Guide.
    Returns:
      the list of stylesheets to use with this scene

  - ### userAgentStylesheetProperty

    public final ObjectProperty<String> userAgentStylesheetProperty()
    Gets the userAgentStylesheet property.
    Returns:
      the userAgentStylesheet property
    Since:
      JavaFX 8u20
    See Also:
      - `getUserAgentStylesheet()`
      - `setUserAgentStylesheet(String)`

  - ### getUserAgentStylesheet

    public final String getUserAgentStylesheet()
    Get the URL of the user-agent stylesheet that will be used by this Scene. If the URL has not been set, the platform-default user-agent stylesheet will be used.

    For additional information about using CSS with the scene graph, see the CSS Reference Guide.

    Returns:
      The URL of the user-agent stylesheet that will be used by this Scene, or null if has not been set.
    Since:
      JavaFX 8u20

  - ### setUserAgentStylesheet

    public final void setUserAgentStylesheet(String url)
    Set the URL of the user-agent stylesheet that will be used by this Scene in place of the the platform-default user-agent stylesheet. If the URL does not resolve to a valid location, the platform-default user-agent stylesheet will be used.

    The URL is a hierarchical URI of the form [scheme:][//authority][path]. If the URL does not have a [scheme:] component, the URL is considered to be the [path] component only. Any leading '/' character of the [path] is ignored and the [path] is treated as a path relative to the root of the application's classpath.

    The RFC 2397 "data" scheme for URLs is supported in addition to the protocol handlers that are registered for the application. If a URL uses the "data" scheme and the MIME type is either empty, "text/plain", or "text/css", the payload will be interpreted as a CSS file. If the MIME type is "application/octet-stream", the payload will be interpreted as a binary CSS file (see `Stylesheet.convertToBinary(File, File)`).

    For additional information about using CSS with the scene graph, see the CSS Reference Guide.

    Parameters:
      `url` - the URL of the user-agent stylesheet
    Since:
      JavaFX 8u20

  - ### isDepthBuffer

    public final boolean isDepthBuffer()
    Retrieves the depth buffer attribute for this scene.
    Returns:
      the depth buffer attribute.

  - ### focusOwnerProperty

    public final ReadOnlyObjectProperty<Node> focusOwnerProperty()
    The scene's current focus owner node. This node's "focused" variable might be false if this scene has no window, or if the window is inactive (window.focused == false).
    Returns:
      the `focusOwner` property
    Since:
      JavaFX 2.2
    See Also:
      - `getFocusOwner()`

  - ### getFocusOwner

    public final Node getFocusOwner()
    Gets the value of the `focusOwner` property.
    Property description:
      The scene's current focus owner node. This node's "focused" variable might be false if this scene has no window, or if the window is inactive (window.focused == false).
    Returns:
      the value of the `focusOwner` property
    Since:
      JavaFX 2.2
    See Also:
      - `focusOwnerProperty()`

  - ### setEventDispatcher

    public final void setEventDispatcher(EventDispatcher value)
    Sets the value of the `eventDispatcher` property.
    Property description:
      Specifies the event dispatcher for this scene. When replacing the value with a new `EventDispatcher`, the new dispatcher should forward events to the replaced dispatcher to keep the scene's default event handling behavior.
    Parameters:
      `value` - the value for the `eventDispatcher` property
    See Also:
      - `getEventDispatcher()`
      - `eventDispatcherProperty()`

  - ### getEventDispatcher

    public final EventDispatcher getEventDispatcher()
    Gets the value of the `eventDispatcher` property.
    Property description:
      Specifies the event dispatcher for this scene. When replacing the value with a new `EventDispatcher`, the new dispatcher should forward events to the replaced dispatcher to keep the scene's default event handling behavior.
    Returns:
      the value of the `eventDispatcher` property
    See Also:
      - `setEventDispatcher(EventDispatcher)`
      - `eventDispatcherProperty()`

  - ### eventDispatcherProperty

    public final ObjectProperty<EventDispatcher> eventDispatcherProperty()
    Specifies the event dispatcher for this scene. When replacing the value with a new `EventDispatcher`, the new dispatcher should forward events to the replaced dispatcher to keep the scene's default event handling behavior.
    Returns:
      the `eventDispatcher` property
    See Also:
      - `getEventDispatcher()`
      - `setEventDispatcher(EventDispatcher)`

  - ### addEventHandler

    public final <T extends Event> void addEventHandler(EventType<T> eventType, EventHandler<? super T> eventHandler)
    Description copied from interface: `EventTarget`
    Registers an event handler for this target.

    The handler is called when the target receives an `Event` of the specified type during the bubbling phase of event delivery.

    Specified by:
      `addEventHandler` in interface `EventTarget`
    Type Parameters:
      `T` - the event class of the handler
    Parameters:
      `eventType` - the type of the events received by the handler
      `eventHandler` - the event handler

  - ### removeEventHandler

    public final <T extends Event> void removeEventHandler(EventType<T> eventType, EventHandler<? super T> eventHandler)
    Description copied from interface: `EventTarget`
    Unregisters a previously registered event handler from this target.

    Since it is possible to register a single `EventHandler` instance for different event types, the caller needs to specify the event type from which the handler should be unregistered.

    Specified by:
      `removeEventHandler` in interface `EventTarget`
    Type Parameters:
      `T` - the event class of the handler
    Parameters:
      `eventType` - the event type from which to unregister
      `eventHandler` - the event handler

  - ### addEventFilter

    public final <T extends Event> void addEventFilter(EventType<T> eventType, EventHandler<? super T> eventFilter)
    Description copied from interface: `EventTarget`
    Registers an event filter for this target.

    The filter is called when the target receives an `Event` of the specified type during the capturing phase of event delivery.

    Specified by:
      `addEventFilter` in interface `EventTarget`
    Type Parameters:
      `T` - the event class of the filter
    Parameters:
      `eventType` - the type of the events received by the filter
      `eventFilter` - the event filter

  - ### removeEventFilter

    public final <T extends Event> void removeEventFilter(EventType<T> eventType, EventHandler<? super T> eventFilter)
    Description copied from interface: `EventTarget`
    Unregisters a previously registered event filter from this target.

    Since it is possible to register a single `EventHandler` instance for different event types, the caller needs to specify the event type from which the filter should be unregistered.

    Specified by:
      `removeEventFilter` in interface `EventTarget`
    Type Parameters:
      `T` - the event class of the filter
    Parameters:
      `eventType` - the event type from which to unregister
      `eventFilter` - the event filter

  - ### setEventHandler

    protected final <T extends Event> void setEventHandler(EventType<T> eventType, EventHandler<? super T> eventHandler)
    Sets the handler to use for this event type. There can only be one such handler specified at a time. This handler is guaranteed to be called first. This is used for registering the user-defined onFoo event handlers.
    Type Parameters:
      `T` - the specific event class of the handler
    Parameters:
      `eventType` - the event type to associate with the given eventHandler
      `eventHandler` - the handler to register, or null to unregister
    Throws:
      `NullPointerException` - if the event type is null

  - ### addMnemonic

    public void addMnemonic(Mnemonic m)
    Registers the specified mnemonic.
    Parameters:
      `m` - The mnemonic

  - ### removeMnemonic

    public void removeMnemonic(Mnemonic m)
    Unregisters the specified mnemonic.
    Parameters:
      `m` - The mnemonic

  - ### getMnemonics

    public ObservableMap<KeyCombination, ObservableList<Mnemonic>> getMnemonics()
    Gets the list of mnemonics for this `Scene`.
    Returns:
      the list of mnemonics

  - ### getAccelerators

    public ObservableMap<KeyCombination, Runnable> getAccelerators()
    Gets the list of accelerators for this `Scene`.
    Returns:
      the list of accelerators

  - ### buildEventDispatchChain

    public EventDispatchChain buildEventDispatchChain(EventDispatchChain tail)
    Description copied from interface: `EventTarget`
    Construct an event dispatch chain for this target. The event dispatch chain contains event dispatchers which might be interested in processing of events targeted at this `EventTarget`. This event target is not automatically added to the chain, so if it wants to process events, it needs to add an `EventDispatcher` for itself to the chain.

    In the case the event target is part of some hierarchy, the chain for it is usually built from event dispatchers collected from the root of the hierarchy to the event target.

    The event dispatch chain is constructed by modifications to the provided initial event dispatch chain. The returned chain should have the initial chain at its end so the dispatchers should be prepended to the initial chain.

    The caller shouldn't assume that the initial chain remains unchanged nor that the returned value will reference a different chain.

    Specified by:
      `buildEventDispatchChain` in interface `EventTarget`
    Parameters:
      `tail` - the initial chain to build from
    Returns:
      the resulting event dispatch chain for this target

  - ### setOnContextMenuRequested

    public final void setOnContextMenuRequested(EventHandler<? super ContextMenuEvent> value)
    Sets the value of the `onContextMenuRequested` property.
    Property description:
      Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Parameters:
      `value` - the value for the `onContextMenuRequested` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnContextMenuRequested()`
      - `onContextMenuRequestedProperty()`

  - ### getOnContextMenuRequested

    public final EventHandler<? super ContextMenuEvent> getOnContextMenuRequested()
    Gets the value of the `onContextMenuRequested` property.
    Property description:
      Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Returns:
      the value of the `onContextMenuRequested` property
    Since:
      JavaFX 2.1
    See Also:
      - `setOnContextMenuRequested(EventHandler)`
      - `onContextMenuRequestedProperty()`

  - ### onContextMenuRequestedProperty

    public final ObjectProperty<EventHandler<? super ContextMenuEvent>> onContextMenuRequestedProperty()
    Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Returns:
      the `onContextMenuRequested` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnContextMenuRequested()`
      - `setOnContextMenuRequested(EventHandler)`

  - ### setOnMouseClicked

    public final void setOnMouseClicked(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMouseClicked` property.
    Property description:
      Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Parameters:
      `value` - the value for the `onMouseClicked` property
    See Also:
      - `getOnMouseClicked()`
      - `onMouseClickedProperty()`

  - ### getOnMouseClicked

    public final EventHandler<? super MouseEvent> getOnMouseClicked()
    Gets the value of the `onMouseClicked` property.
    Property description:
      Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Returns:
      the value of the `onMouseClicked` property
    See Also:
      - `setOnMouseClicked(EventHandler)`
      - `onMouseClickedProperty()`

  - ### onMouseClickedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseClickedProperty()
    Defines a function to be called when a mouse button has been clicked (pressed and released) on this `Scene`.
    Returns:
      the `onMouseClicked` property
    See Also:
      - `getOnMouseClicked()`
      - `setOnMouseClicked(EventHandler)`

  - ### setOnMouseDragged

    public final void setOnMouseDragged(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMouseDragged` property.
    Property description:
      Defines a function to be called when a mouse button is pressed on this `Scene` and then dragged.
    Parameters:
      `value` - the value for the `onMouseDragged` property
    See Also:
      - `getOnMouseDragged()`
      - `onMouseDraggedProperty()`

  - ### getOnMouseDragged

    public final EventHandler<? super MouseEvent> getOnMouseDragged()
    Gets the value of the `onMouseDragged` property.
    Property description:
      Defines a function to be called when a mouse button is pressed on this `Scene` and then dragged.
    Returns:
      the value of the `onMouseDragged` property
    See Also:
      - `setOnMouseDragged(EventHandler)`
      - `onMouseDraggedProperty()`

  - ### onMouseDraggedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseDraggedProperty()
    Defines a function to be called when a mouse button is pressed on this `Scene` and then dragged.
    Returns:
      the `onMouseDragged` property
    See Also:
      - `getOnMouseDragged()`
      - `setOnMouseDragged(EventHandler)`

  - ### setOnMouseEntered

    public final void setOnMouseEntered(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMouseEntered` property.
    Property description:
      Defines a function to be called when the mouse enters this `Scene`.
    Parameters:
      `value` - the value for the `onMouseEntered` property
    See Also:
      - `getOnMouseEntered()`
      - `onMouseEnteredProperty()`

  - ### getOnMouseEntered

    public final EventHandler<? super MouseEvent> getOnMouseEntered()
    Gets the value of the `onMouseEntered` property.
    Property description:
      Defines a function to be called when the mouse enters this `Scene`.
    Returns:
      the value of the `onMouseEntered` property
    See Also:
      - `setOnMouseEntered(EventHandler)`
      - `onMouseEnteredProperty()`

  - ### onMouseEnteredProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseEnteredProperty()
    Defines a function to be called when the mouse enters this `Scene`.
    Returns:
      the `onMouseEntered` property
    See Also:
      - `getOnMouseEntered()`
      - `setOnMouseEntered(EventHandler)`

  - ### setOnMouseExited

    public final void setOnMouseExited(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMouseExited` property.
    Property description:
      Defines a function to be called when the mouse exits this `Scene`.
    Parameters:
      `value` - the value for the `onMouseExited` property
    See Also:
      - `getOnMouseExited()`
      - `onMouseExitedProperty()`

  - ### getOnMouseExited

    public final EventHandler<? super MouseEvent> getOnMouseExited()
    Gets the value of the `onMouseExited` property.
    Property description:
      Defines a function to be called when the mouse exits this `Scene`.
    Returns:
      the value of the `onMouseExited` property
    See Also:
      - `setOnMouseExited(EventHandler)`
      - `onMouseExitedProperty()`

  - ### onMouseExitedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseExitedProperty()
    Defines a function to be called when the mouse exits this `Scene`.
    Returns:
      the `onMouseExited` property
    See Also:
      - `getOnMouseExited()`
      - `setOnMouseExited(EventHandler)`

  - ### setOnMouseMoved

    public final void setOnMouseMoved(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMouseMoved` property.
    Property description:
      Defines a function to be called when mouse cursor moves within this `Scene` but no buttons have been pushed.
    Parameters:
      `value` - the value for the `onMouseMoved` property
    See Also:
      - `getOnMouseMoved()`
      - `onMouseMovedProperty()`

  - ### getOnMouseMoved

    public final EventHandler<? super MouseEvent> getOnMouseMoved()
    Gets the value of the `onMouseMoved` property.
    Property description:
      Defines a function to be called when mouse cursor moves within this `Scene` but no buttons have been pushed.
    Returns:
      the value of the `onMouseMoved` property
    See Also:
      - `setOnMouseMoved(EventHandler)`
      - `onMouseMovedProperty()`

  - ### onMouseMovedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseMovedProperty()
    Defines a function to be called when mouse cursor moves within this `Scene` but no buttons have been pushed.
    Returns:
      the `onMouseMoved` property
    See Also:
      - `getOnMouseMoved()`
      - `setOnMouseMoved(EventHandler)`

  - ### setOnMousePressed

    public final void setOnMousePressed(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMousePressed` property.
    Property description:
      Defines a function to be called when a mouse button has been pressed on this `Scene`.
    Parameters:
      `value` - the value for the `onMousePressed` property
    See Also:
      - `getOnMousePressed()`
      - `onMousePressedProperty()`

  - ### getOnMousePressed

    public final EventHandler<? super MouseEvent> getOnMousePressed()
    Gets the value of the `onMousePressed` property.
    Property description:
      Defines a function to be called when a mouse button has been pressed on this `Scene`.
    Returns:
      the value of the `onMousePressed` property
    See Also:
      - `setOnMousePressed(EventHandler)`
      - `onMousePressedProperty()`

  - ### onMousePressedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMousePressedProperty()
    Defines a function to be called when a mouse button has been pressed on this `Scene`.
    Returns:
      the `onMousePressed` property
    See Also:
      - `getOnMousePressed()`
      - `setOnMousePressed(EventHandler)`

  - ### setOnMouseReleased

    public final void setOnMouseReleased(EventHandler<? super MouseEvent> value)
    Sets the value of the `onMouseReleased` property.
    Property description:
      Defines a function to be called when a mouse button has been released on this `Scene`.
    Parameters:
      `value` - the value for the `onMouseReleased` property
    See Also:
      - `getOnMouseReleased()`
      - `onMouseReleasedProperty()`

  - ### getOnMouseReleased

    public final EventHandler<? super MouseEvent> getOnMouseReleased()
    Gets the value of the `onMouseReleased` property.
    Property description:
      Defines a function to be called when a mouse button has been released on this `Scene`.
    Returns:
      the value of the `onMouseReleased` property
    See Also:
      - `setOnMouseReleased(EventHandler)`
      - `onMouseReleasedProperty()`

  - ### onMouseReleasedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onMouseReleasedProperty()
    Defines a function to be called when a mouse button has been released on this `Scene`.
    Returns:
      the `onMouseReleased` property
    See Also:
      - `getOnMouseReleased()`
      - `setOnMouseReleased(EventHandler)`

  - ### setOnDragDetected

    public final void setOnDragDetected(EventHandler<? super MouseEvent> value)
    Sets the value of the `onDragDetected` property.
    Property description:
      Defines a function to be called when drag gesture has been detected. This is the right place to start drag and drop operation.
    Parameters:
      `value` - the value for the `onDragDetected` property
    See Also:
      - `getOnDragDetected()`
      - `onDragDetectedProperty()`

  - ### getOnDragDetected

    public final EventHandler<? super MouseEvent> getOnDragDetected()
    Gets the value of the `onDragDetected` property.
    Property description:
      Defines a function to be called when drag gesture has been detected. This is the right place to start drag and drop operation.
    Returns:
      the value of the `onDragDetected` property
    See Also:
      - `setOnDragDetected(EventHandler)`
      - `onDragDetectedProperty()`

  - ### onDragDetectedProperty

    public final ObjectProperty<EventHandler<? super MouseEvent>> onDragDetectedProperty()
    Defines a function to be called when drag gesture has been detected. This is the right place to start drag and drop operation.
    Returns:
      the `onDragDetected` property
    See Also:
      - `getOnDragDetected()`
      - `setOnDragDetected(EventHandler)`

  - ### setOnMouseDragOver

    public final void setOnMouseDragOver(EventHandler<? super MouseDragEvent> value)
    Sets the value of the `onMouseDragOver` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture progresses within this `Scene`.
    Parameters:
      `value` - the value for the `onMouseDragOver` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragOver()`
      - `onMouseDragOverProperty()`

  - ### getOnMouseDragOver

    public final EventHandler<? super MouseDragEvent> getOnMouseDragOver()
    Gets the value of the `onMouseDragOver` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture progresses within this `Scene`.
    Returns:
      the value of the `onMouseDragOver` property
    Since:
      JavaFX 2.1
    See Also:
      - `setOnMouseDragOver(EventHandler)`
      - `onMouseDragOverProperty()`

  - ### onMouseDragOverProperty

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragOverProperty()
    Defines a function to be called when a full press-drag-release gesture progresses within this `Scene`.
    Returns:
      the `onMouseDragOver` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragOver()`
      - `setOnMouseDragOver(EventHandler)`

  - ### setOnMouseDragReleased

    public final void setOnMouseDragReleased(EventHandler<? super MouseDragEvent> value)
    Sets the value of the `onMouseDragReleased` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture ends within this `Scene`.
    Parameters:
      `value` - the value for the `onMouseDragReleased` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragReleased()`
      - `onMouseDragReleasedProperty()`

  - ### getOnMouseDragReleased

    public final EventHandler<? super MouseDragEvent> getOnMouseDragReleased()
    Gets the value of the `onMouseDragReleased` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture ends within this `Scene`.
    Returns:
      the value of the `onMouseDragReleased` property
    Since:
      JavaFX 2.1
    See Also:
      - `setOnMouseDragReleased(EventHandler)`
      - `onMouseDragReleasedProperty()`

  - ### onMouseDragReleasedProperty

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragReleasedProperty()
    Defines a function to be called when a full press-drag-release gesture ends within this `Scene`.
    Returns:
      the `onMouseDragReleased` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragReleased()`
      - `setOnMouseDragReleased(EventHandler)`

  - ### setOnMouseDragEntered

    public final void setOnMouseDragEntered(EventHandler<? super MouseDragEvent> value)
    Sets the value of the `onMouseDragEntered` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture enters this `Scene`.
    Parameters:
      `value` - the value for the `onMouseDragEntered` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragEntered()`
      - `onMouseDragEnteredProperty()`

  - ### getOnMouseDragEntered

    public final EventHandler<? super MouseDragEvent> getOnMouseDragEntered()
    Gets the value of the `onMouseDragEntered` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture enters this `Scene`.
    Returns:
      the value of the `onMouseDragEntered` property
    Since:
      JavaFX 2.1
    See Also:
      - `setOnMouseDragEntered(EventHandler)`
      - `onMouseDragEnteredProperty()`

  - ### onMouseDragEnteredProperty

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragEnteredProperty()
    Defines a function to be called when a full press-drag-release gesture enters this `Scene`.
    Returns:
      the `onMouseDragEntered` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragEntered()`
      - `setOnMouseDragEntered(EventHandler)`

  - ### setOnMouseDragExited

    public final void setOnMouseDragExited(EventHandler<? super MouseDragEvent> value)
    Sets the value of the `onMouseDragExited` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture exits this `Scene`.
    Parameters:
      `value` - the value for the `onMouseDragExited` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragExited()`
      - `onMouseDragExitedProperty()`

  - ### getOnMouseDragExited

    public final EventHandler<? super MouseDragEvent> getOnMouseDragExited()
    Gets the value of the `onMouseDragExited` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture exits this `Scene`.
    Returns:
      the value of the `onMouseDragExited` property
    Since:
      JavaFX 2.1
    See Also:
      - `setOnMouseDragExited(EventHandler)`
      - `onMouseDragExitedProperty()`

  - ### onMouseDragExitedProperty

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragExitedProperty()
    Defines a function to be called when a full press-drag-release gesture exits this `Scene`.
    Returns:
      the `onMouseDragExited` property
    Since:
      JavaFX 2.1
    See Also:
      - `getOnMouseDragExited()`
      - `setOnMouseDragExited(EventHandler)`

  - ### setOnMouseDragDone

    public final void setOnMouseDragDone(EventHandler<? super MouseDragEvent> value)
    Sets the value of the `onMouseDragDone` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture ends.
    Parameters:
      `value` - the value for the `onMouseDragDone` property
    Since:
      26
    See Also:
      - `getOnMouseDragDone()`
      - `onMouseDragDoneProperty()`

  - ### getOnMouseDragDone

    public final EventHandler<? super MouseDragEvent> getOnMouseDragDone()
    Gets the value of the `onMouseDragDone` property.
    Property description:
      Defines a function to be called when a full press-drag-release gesture ends.
    Returns:
      the value of the `onMouseDragDone` property
    Since:
      26
    See Also:
      - `setOnMouseDragDone(EventHandler)`
      - `onMouseDragDoneProperty()`

  - ### onMouseDragDoneProperty

    public final ObjectProperty<EventHandler<? super MouseDragEvent>> onMouseDragDoneProperty()
    Defines a function to be called when a full press-drag-release gesture ends.
    Returns:
      the `onMouseDragDone` property
    Since:
      26
    See Also:
      - `getOnMouseDragDone()`
      - `setOnMouseDragDone(EventHandler)`

  - ### setOnScrollStarted

    public final void setOnScrollStarted(EventHandler<? super ScrollEvent> value)
    Sets the value of the `onScrollStarted` property.
    Property description:
      Defines a function to be called when a scrolling gesture is detected.
    Parameters:
      `value` - the value for the `onScrollStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnScrollStarted()`
      - `onScrollStartedProperty()`

  - ### getOnScrollStarted

    public final EventHandler<? super ScrollEvent> getOnScrollStarted()
    Gets the value of the `onScrollStarted` property.
    Property description:
      Defines a function to be called when a scrolling gesture is detected.
    Returns:
      the value of the `onScrollStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnScrollStarted(EventHandler)`
      - `onScrollStartedProperty()`

  - ### onScrollStartedProperty

    public final ObjectProperty<EventHandler<? super ScrollEvent>> onScrollStartedProperty()
    Defines a function to be called when a scrolling gesture is detected.
    Returns:
      the `onScrollStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnScrollStarted()`
      - `setOnScrollStarted(EventHandler)`

  - ### setOnScroll

    public final void setOnScroll(EventHandler<? super ScrollEvent> value)
    Sets the value of the `onScroll` property.
    Property description:
      Defines a function to be called when user performs a scrolling action.
    Parameters:
      `value` - the value for the `onScroll` property
    See Also:
      - `getOnScroll()`
      - `onScrollProperty()`

  - ### getOnScroll

    public final EventHandler<? super ScrollEvent> getOnScroll()
    Gets the value of the `onScroll` property.
    Property description:
      Defines a function to be called when user performs a scrolling action.
    Returns:
      the value of the `onScroll` property
    See Also:
      - `setOnScroll(EventHandler)`
      - `onScrollProperty()`

  - ### onScrollProperty

    public final ObjectProperty<EventHandler<? super ScrollEvent>> onScrollProperty()
    Defines a function to be called when user performs a scrolling action.
    Returns:
      the `onScroll` property
    See Also:
      - `getOnScroll()`
      - `setOnScroll(EventHandler)`

  - ### setOnScrollFinished

    public final void setOnScrollFinished(EventHandler<? super ScrollEvent> value)
    Sets the value of the `onScrollFinished` property.
    Property description:
      Defines a function to be called when a scrolling gesture ends.
    Parameters:
      `value` - the value for the `onScrollFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnScrollFinished()`
      - `onScrollFinishedProperty()`

  - ### getOnScrollFinished

    public final EventHandler<? super ScrollEvent> getOnScrollFinished()
    Gets the value of the `onScrollFinished` property.
    Property description:
      Defines a function to be called when a scrolling gesture ends.
    Returns:
      the value of the `onScrollFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnScrollFinished(EventHandler)`
      - `onScrollFinishedProperty()`

  - ### onScrollFinishedProperty

    public final ObjectProperty<EventHandler<? super ScrollEvent>> onScrollFinishedProperty()
    Defines a function to be called when a scrolling gesture ends.
    Returns:
      the `onScrollFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnScrollFinished()`
      - `setOnScrollFinished(EventHandler)`

  - ### setOnRotationStarted

    public final void setOnRotationStarted(EventHandler<? super RotateEvent> value)
    Sets the value of the `onRotationStarted` property.
    Property description:
      Defines a function to be called when a rotating gesture is detected.
    Parameters:
      `value` - the value for the `onRotationStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotationStarted()`
      - `onRotationStartedProperty()`

  - ### getOnRotationStarted

    public final EventHandler<? super RotateEvent> getOnRotationStarted()
    Gets the value of the `onRotationStarted` property.
    Property description:
      Defines a function to be called when a rotating gesture is detected.
    Returns:
      the value of the `onRotationStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnRotationStarted(EventHandler)`
      - `onRotationStartedProperty()`

  - ### onRotationStartedProperty

    public final ObjectProperty<EventHandler<? super RotateEvent>> onRotationStartedProperty()
    Defines a function to be called when a rotating gesture is detected.
    Returns:
      the `onRotationStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotationStarted()`
      - `setOnRotationStarted(EventHandler)`

  - ### setOnRotate

    public final void setOnRotate(EventHandler<? super RotateEvent> value)
    Sets the value of the `onRotate` property.
    Property description:
      Defines a function to be called when user performs a rotating action.
    Parameters:
      `value` - the value for the `onRotate` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotate()`
      - `onRotateProperty()`

  - ### getOnRotate

    public final EventHandler<? super RotateEvent> getOnRotate()
    Gets the value of the `onRotate` property.
    Property description:
      Defines a function to be called when user performs a rotating action.
    Returns:
      the value of the `onRotate` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnRotate(EventHandler)`
      - `onRotateProperty()`

  - ### onRotateProperty

    public final ObjectProperty<EventHandler<? super RotateEvent>> onRotateProperty()
    Defines a function to be called when user performs a rotating action.
    Returns:
      the `onRotate` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotate()`
      - `setOnRotate(EventHandler)`

  - ### setOnRotationFinished

    public final void setOnRotationFinished(EventHandler<? super RotateEvent> value)
    Sets the value of the `onRotationFinished` property.
    Property description:
      Defines a function to be called when a rotating gesture ends.
    Parameters:
      `value` - the value for the `onRotationFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotationFinished()`
      - `onRotationFinishedProperty()`

  - ### getOnRotationFinished

    public final EventHandler<? super RotateEvent> getOnRotationFinished()
    Gets the value of the `onRotationFinished` property.
    Property description:
      Defines a function to be called when a rotating gesture ends.
    Returns:
      the value of the `onRotationFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnRotationFinished(EventHandler)`
      - `onRotationFinishedProperty()`

  - ### onRotationFinishedProperty

    public final ObjectProperty<EventHandler<? super RotateEvent>> onRotationFinishedProperty()
    Defines a function to be called when a rotating gesture ends.
    Returns:
      the `onRotationFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnRotationFinished()`
      - `setOnRotationFinished(EventHandler)`

  - ### setOnZoomStarted

    public final void setOnZoomStarted(EventHandler<? super ZoomEvent> value)
    Sets the value of the `onZoomStarted` property.
    Property description:
      Defines a function to be called when a zooming gesture is detected.
    Parameters:
      `value` - the value for the `onZoomStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoomStarted()`
      - `onZoomStartedProperty()`

  - ### getOnZoomStarted

    public final EventHandler<? super ZoomEvent> getOnZoomStarted()
    Gets the value of the `onZoomStarted` property.
    Property description:
      Defines a function to be called when a zooming gesture is detected.
    Returns:
      the value of the `onZoomStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnZoomStarted(EventHandler)`
      - `onZoomStartedProperty()`

  - ### onZoomStartedProperty

    public final ObjectProperty<EventHandler<? super ZoomEvent>> onZoomStartedProperty()
    Defines a function to be called when a zooming gesture is detected.
    Returns:
      the `onZoomStarted` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoomStarted()`
      - `setOnZoomStarted(EventHandler)`

  - ### setOnZoom

    public final void setOnZoom(EventHandler<? super ZoomEvent> value)
    Sets the value of the `onZoom` property.
    Property description:
      Defines a function to be called when user performs a zooming action.
    Parameters:
      `value` - the value for the `onZoom` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoom()`
      - `onZoomProperty()`

  - ### getOnZoom

    public final EventHandler<? super ZoomEvent> getOnZoom()
    Gets the value of the `onZoom` property.
    Property description:
      Defines a function to be called when user performs a zooming action.
    Returns:
      the value of the `onZoom` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnZoom(EventHandler)`
      - `onZoomProperty()`

  - ### onZoomProperty

    public final ObjectProperty<EventHandler<? super ZoomEvent>> onZoomProperty()
    Defines a function to be called when user performs a zooming action.
    Returns:
      the `onZoom` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoom()`
      - `setOnZoom(EventHandler)`

  - ### setOnZoomFinished

    public final void setOnZoomFinished(EventHandler<? super ZoomEvent> value)
    Sets the value of the `onZoomFinished` property.
    Property description:
      Defines a function to be called when a zooming gesture ends.
    Parameters:
      `value` - the value for the `onZoomFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoomFinished()`
      - `onZoomFinishedProperty()`

  - ### getOnZoomFinished

    public final EventHandler<? super ZoomEvent> getOnZoomFinished()
    Gets the value of the `onZoomFinished` property.
    Property description:
      Defines a function to be called when a zooming gesture ends.
    Returns:
      the value of the `onZoomFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnZoomFinished(EventHandler)`
      - `onZoomFinishedProperty()`

  - ### onZoomFinishedProperty

    public final ObjectProperty<EventHandler<? super ZoomEvent>> onZoomFinishedProperty()
    Defines a function to be called when a zooming gesture ends.
    Returns:
      the `onZoomFinished` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnZoomFinished()`
      - `setOnZoomFinished(EventHandler)`

  - ### setOnSwipeUp

    public final void setOnSwipeUp(EventHandler<? super SwipeEvent> value)
    Sets the value of the `onSwipeUp` property.
    Property description:
      Defines a function to be called when an upward swipe gesture happens in this scene.
    Parameters:
      `value` - the value for the `onSwipeUp` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeUp()`
      - `onSwipeUpProperty()`

  - ### getOnSwipeUp

    public final EventHandler<? super SwipeEvent> getOnSwipeUp()
    Gets the value of the `onSwipeUp` property.
    Property description:
      Defines a function to be called when an upward swipe gesture happens in this scene.
    Returns:
      the value of the `onSwipeUp` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnSwipeUp(EventHandler)`
      - `onSwipeUpProperty()`

  - ### onSwipeUpProperty

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeUpProperty()
    Defines a function to be called when an upward swipe gesture happens in this scene.
    Returns:
      the `onSwipeUp` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeUp()`
      - `setOnSwipeUp(EventHandler)`

  - ### setOnSwipeDown

    public final void setOnSwipeDown(EventHandler<? super SwipeEvent> value)
    Sets the value of the `onSwipeDown` property.
    Property description:
      Defines a function to be called when an downward swipe gesture happens in this scene.
    Parameters:
      `value` - the value for the `onSwipeDown` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeDown()`
      - `onSwipeDownProperty()`

  - ### getOnSwipeDown

    public final EventHandler<? super SwipeEvent> getOnSwipeDown()
    Gets the value of the `onSwipeDown` property.
    Property description:
      Defines a function to be called when an downward swipe gesture happens in this scene.
    Returns:
      the value of the `onSwipeDown` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnSwipeDown(EventHandler)`
      - `onSwipeDownProperty()`

  - ### onSwipeDownProperty

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeDownProperty()
    Defines a function to be called when an downward swipe gesture happens in this scene.
    Returns:
      the `onSwipeDown` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeDown()`
      - `setOnSwipeDown(EventHandler)`

  - ### setOnSwipeLeft

    public final void setOnSwipeLeft(EventHandler<? super SwipeEvent> value)
    Sets the value of the `onSwipeLeft` property.
    Property description:
      Defines a function to be called when an leftward swipe gesture happens in this scene.
    Parameters:
      `value` - the value for the `onSwipeLeft` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeLeft()`
      - `onSwipeLeftProperty()`

  - ### getOnSwipeLeft

    public final EventHandler<? super SwipeEvent> getOnSwipeLeft()
    Gets the value of the `onSwipeLeft` property.
    Property description:
      Defines a function to be called when an leftward swipe gesture happens in this scene.
    Returns:
      the value of the `onSwipeLeft` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnSwipeLeft(EventHandler)`
      - `onSwipeLeftProperty()`

  - ### onSwipeLeftProperty

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeLeftProperty()
    Defines a function to be called when an leftward swipe gesture happens in this scene.
    Returns:
      the `onSwipeLeft` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeLeft()`
      - `setOnSwipeLeft(EventHandler)`

  - ### setOnSwipeRight

    public final void setOnSwipeRight(EventHandler<? super SwipeEvent> value)
    Sets the value of the `onSwipeRight` property.
    Property description:
      Defines a function to be called when an rightward swipe gesture happens in this scene.
    Parameters:
      `value` - the value for the `onSwipeRight` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeRight()`
      - `onSwipeRightProperty()`

  - ### getOnSwipeRight

    public final EventHandler<? super SwipeEvent> getOnSwipeRight()
    Gets the value of the `onSwipeRight` property.
    Property description:
      Defines a function to be called when an rightward swipe gesture happens in this scene.
    Returns:
      the value of the `onSwipeRight` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnSwipeRight(EventHandler)`
      - `onSwipeRightProperty()`

  - ### onSwipeRightProperty

    public final ObjectProperty<EventHandler<? super SwipeEvent>> onSwipeRightProperty()
    Defines a function to be called when an rightward swipe gesture happens in this scene.
    Returns:
      the `onSwipeRight` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnSwipeRight()`
      - `setOnSwipeRight(EventHandler)`

  - ### setOnTouchPressed

    public final void setOnTouchPressed(EventHandler<? super TouchEvent> value)
    Sets the value of the `onTouchPressed` property.
    Property description:
      Defines a function to be called when a new touch point is pressed.
    Parameters:
      `value` - the value for the `onTouchPressed` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchPressed()`
      - `onTouchPressedProperty()`

  - ### getOnTouchPressed

    public final EventHandler<? super TouchEvent> getOnTouchPressed()
    Gets the value of the `onTouchPressed` property.
    Property description:
      Defines a function to be called when a new touch point is pressed.
    Returns:
      the value of the `onTouchPressed` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnTouchPressed(EventHandler)`
      - `onTouchPressedProperty()`

  - ### onTouchPressedProperty

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchPressedProperty()
    Defines a function to be called when a new touch point is pressed.
    Returns:
      the `onTouchPressed` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchPressed()`
      - `setOnTouchPressed(EventHandler)`

  - ### setOnTouchMoved

    public final void setOnTouchMoved(EventHandler<? super TouchEvent> value)
    Sets the value of the `onTouchMoved` property.
    Property description:
      Defines a function to be called when a touch point is moved.
    Parameters:
      `value` - the value for the `onTouchMoved` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchMoved()`
      - `onTouchMovedProperty()`

  - ### getOnTouchMoved

    public final EventHandler<? super TouchEvent> getOnTouchMoved()
    Gets the value of the `onTouchMoved` property.
    Property description:
      Defines a function to be called when a touch point is moved.
    Returns:
      the value of the `onTouchMoved` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnTouchMoved(EventHandler)`
      - `onTouchMovedProperty()`

  - ### onTouchMovedProperty

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchMovedProperty()
    Defines a function to be called when a touch point is moved.
    Returns:
      the `onTouchMoved` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchMoved()`
      - `setOnTouchMoved(EventHandler)`

  - ### setOnTouchReleased

    public final void setOnTouchReleased(EventHandler<? super TouchEvent> value)
    Sets the value of the `onTouchReleased` property.
    Property description:
      Defines a function to be called when a new touch point is pressed.
    Parameters:
      `value` - the value for the `onTouchReleased` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchReleased()`
      - `onTouchReleasedProperty()`

  - ### getOnTouchReleased

    public final EventHandler<? super TouchEvent> getOnTouchReleased()
    Gets the value of the `onTouchReleased` property.
    Property description:
      Defines a function to be called when a new touch point is pressed.
    Returns:
      the value of the `onTouchReleased` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnTouchReleased(EventHandler)`
      - `onTouchReleasedProperty()`

  - ### onTouchReleasedProperty

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchReleasedProperty()
    Defines a function to be called when a new touch point is pressed.
    Returns:
      the `onTouchReleased` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchReleased()`
      - `setOnTouchReleased(EventHandler)`

  - ### setOnTouchStationary

    public final void setOnTouchStationary(EventHandler<? super TouchEvent> value)
    Sets the value of the `onTouchStationary` property.
    Property description:
      Defines a function to be called when a touch point stays pressed and still.
    Parameters:
      `value` - the value for the `onTouchStationary` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchStationary()`
      - `onTouchStationaryProperty()`

  - ### getOnTouchStationary

    public final EventHandler<? super TouchEvent> getOnTouchStationary()
    Gets the value of the `onTouchStationary` property.
    Property description:
      Defines a function to be called when a touch point stays pressed and still.
    Returns:
      the value of the `onTouchStationary` property
    Since:
      JavaFX 2.2
    See Also:
      - `setOnTouchStationary(EventHandler)`
      - `onTouchStationaryProperty()`

  - ### onTouchStationaryProperty

    public final ObjectProperty<EventHandler<? super TouchEvent>> onTouchStationaryProperty()
    Defines a function to be called when a touch point stays pressed and still.
    Returns:
      the `onTouchStationary` property
    Since:
      JavaFX 2.2
    See Also:
      - `getOnTouchStationary()`
      - `setOnTouchStationary(EventHandler)`

  - ### setOnDragEntered

    public final void setOnDragEntered(EventHandler<? super DragEvent> value)
    Sets the value of the `onDragEntered` property.
    Property description:
      Defines a function to be called when drag gesture enters this `Scene`.
    Parameters:
      `value` - the value for the `onDragEntered` property
    See Also:
      - `getOnDragEntered()`
      - `onDragEnteredProperty()`

  - ### getOnDragEntered

    public final EventHandler<? super DragEvent> getOnDragEntered()
    Gets the value of the `onDragEntered` property.
    Property description:
      Defines a function to be called when drag gesture enters this `Scene`.
    Returns:
      the value of the `onDragEntered` property
    See Also:
      - `setOnDragEntered(EventHandler)`
      - `onDragEnteredProperty()`

  - ### onDragEnteredProperty

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragEnteredProperty()
    Defines a function to be called when drag gesture enters this `Scene`.
    Returns:
      function to be called when drag gesture enters this scene
    See Also:
      - `getOnDragEntered()`
      - `setOnDragEntered(EventHandler)`

  - ### setOnDragExited

    public final void setOnDragExited(EventHandler<? super DragEvent> value)
    Sets the value of the `onDragExited` property.
    Property description:
      Defines a function to be called when drag gesture exits this `Scene`.
    Parameters:
      `value` - the value for the `onDragExited` property
    See Also:
      - `getOnDragExited()`
      - `onDragExitedProperty()`

  - ### getOnDragExited

    public final EventHandler<? super DragEvent> getOnDragExited()
    Gets the value of the `onDragExited` property.
    Property description:
      Defines a function to be called when drag gesture exits this `Scene`.
    Returns:
      the value of the `onDragExited` property
    See Also:
      - `setOnDragExited(EventHandler)`
      - `onDragExitedProperty()`

  - ### onDragExitedProperty

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragExitedProperty()
    Defines a function to be called when drag gesture exits this `Scene`.
    Returns:
      the function to be called when drag gesture exits this scene
    See Also:
      - `getOnDragExited()`
      - `setOnDragExited(EventHandler)`

  - ### setOnDragOver

    public final void setOnDragOver(EventHandler<? super DragEvent> value)
    Sets the value of the `onDragOver` property.
    Property description:
      Defines a function to be called when drag gesture progresses within this `Scene`.
    Parameters:
      `value` - the value for the `onDragOver` property
    See Also:
      - `getOnDragOver()`
      - `onDragOverProperty()`

  - ### getOnDragOver

    public final EventHandler<? super DragEvent> getOnDragOver()
    Gets the value of the `onDragOver` property.
    Property description:
      Defines a function to be called when drag gesture progresses within this `Scene`.
    Returns:
      the value of the `onDragOver` property
    See Also:
      - `setOnDragOver(EventHandler)`
      - `onDragOverProperty()`

  - ### onDragOverProperty

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragOverProperty()
    Defines a function to be called when drag gesture progresses within this `Scene`.
    Returns:
      the function to be called when drag gesture progresses within this scene
    See Also:
      - `getOnDragOver()`
      - `setOnDragOver(EventHandler)`

  - ### setOnDragDropped

    public final void setOnDragDropped(EventHandler<? super DragEvent> value)
    Sets the value of the `onDragDropped` property.
    Property description:
      Defines a function to be called when the mouse button is released on this `Scene` during drag and drop gesture. Transfer of data from the `DragEvent`'s `dragboard` should happen in this function.
    Parameters:
      `value` - the value for the `onDragDropped` property
    See Also:
      - `getOnDragDropped()`
      - `onDragDroppedProperty()`

  - ### getOnDragDropped

    public final EventHandler<? super DragEvent> getOnDragDropped()
    Gets the value of the `onDragDropped` property.
    Property description:
      Defines a function to be called when the mouse button is released on this `Scene` during drag and drop gesture. Transfer of data from the `DragEvent`'s `dragboard` should happen in this function.
    Returns:
      the value of the `onDragDropped` property
    See Also:
      - `setOnDragDropped(EventHandler)`
      - `onDragDroppedProperty()`

  - ### onDragDroppedProperty

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragDroppedProperty()
    Defines a function to be called when the mouse button is released on this `Scene` during drag and drop gesture. Transfer of data from the `DragEvent`'s `dragboard` should happen in this function.
    Returns:
      the function to be called when the mouse button is released on this scene during drag and drop gesture
    See Also:
      - `getOnDragDropped()`
      - `setOnDragDropped(EventHandler)`

  - ### setOnDragDone

    public final void setOnDragDone(EventHandler<? super DragEvent> value)
    Sets the value of the `onDragDone` property.
    Property description:
      Defines a function to be called when this `Scene` is a drag and drop gesture source after its data has been dropped on a drop target. The `transferMode` of the event shows what just happened at the drop target. If `transferMode` has the value `MOVE`, then the source can clear out its data. Clearing the source's data gives the appropriate appearance to a user that the data has been moved by the drag and drop gesture. A `transferMode` that has the value `NONE` indicates that no data was transferred during the drag and drop gesture. Positional data for the `DragEvent` is invalid. Valid positional data for the `DragEvent` is presented in the `onDragDropped` event handler.
    Parameters:
      `value` - the value for the `onDragDone` property
    See Also:
      - `getOnDragDone()`
      - `onDragDoneProperty()`

  - ### getOnDragDone

    public final EventHandler<? super DragEvent> getOnDragDone()
    Gets the value of the `onDragDone` property.
    Property description:
      Defines a function to be called when this `Scene` is a drag and drop gesture source after its data has been dropped on a drop target. The `transferMode` of the event shows what just happened at the drop target. If `transferMode` has the value `MOVE`, then the source can clear out its data. Clearing the source's data gives the appropriate appearance to a user that the data has been moved by the drag and drop gesture. A `transferMode` that has the value `NONE` indicates that no data was transferred during the drag and drop gesture. Positional data for the `DragEvent` is invalid. Valid positional data for the `DragEvent` is presented in the `onDragDropped` event handler.
    Returns:
      the value of the `onDragDone` property
    See Also:
      - `setOnDragDone(EventHandler)`
      - `onDragDoneProperty()`

  - ### onDragDoneProperty

    public final ObjectProperty<EventHandler<? super DragEvent>> onDragDoneProperty()
    Defines a function to be called when this `Scene` is a drag and drop gesture source after its data has been dropped on a drop target. The `transferMode` of the event shows what just happened at the drop target. If `transferMode` has the value `MOVE`, then the source can clear out its data. Clearing the source's data gives the appropriate appearance to a user that the data has been moved by the drag and drop gesture. A `transferMode` that has the value `NONE` indicates that no data was transferred during the drag and drop gesture. Positional data for the `DragEvent` is invalid. Valid positional data for the `DragEvent` is presented in the `onDragDropped` event handler.
    Returns:
      the function to be called when this scene is a drag and drop gesture source after its data has been dropped on a drop target
    See Also:
      - `getOnDragDone()`
      - `setOnDragDone(EventHandler)`

  - ### startDragAndDrop

    public Dragboard startDragAndDrop(TransferMode... transferModes)
    Confirms a potential drag and drop gesture that is recognized over this `Scene`. Can be called only from a DRAG_DETECTED event handler. The returned `Dragboard` is used to transfer data during the drag and drop gesture. Placing this `Scene`'s data on the `Dragboard` also identifies this `Scene` as the source of the drag and drop gesture. More detail about drag and drop gestures is described in the overivew of `DragEvent`.
    Parameters:
      `transferModes` - The supported `TransferMode`(s) of this `Node`
    Returns:
      A `Dragboard` to place this `Scene`'s data on
    Throws:
      `IllegalStateException` - if drag and drop cannot be started at this moment (it's called outside of `DRAG_DETECTED` event handling).
    See Also:
      - `DragEvent`

  - ### startFullDrag

    public void startFullDrag()
    Starts a full press-drag-release gesture with this scene as gesture source. This method can be called only from a `DRAG_DETECTED` mouse event handler. More detail about dragging gestures can be found in the overview of `MouseEvent` and `MouseDragEvent`.
    Throws:
      `IllegalStateException` - if the full press-drag-release gesture cannot be started at this moment (it's called outside of `DRAG_DETECTED` event handling).
    Since:
      JavaFX 2.1
    See Also:
      - `MouseEvent`
      - `MouseDragEvent`

  - ### setOnKeyPressed

    public final void setOnKeyPressed(EventHandler<? super KeyEvent> value)
    Sets the value of the `onKeyPressed` property.
    Property description:
      Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been pressed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Parameters:
      `value` - the value for the `onKeyPressed` property
    See Also:
      - `getOnKeyPressed()`
      - `onKeyPressedProperty()`

  - ### getOnKeyPressed

    public final EventHandler<? super KeyEvent> getOnKeyPressed()
    Gets the value of the `onKeyPressed` property.
    Property description:
      Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been pressed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Returns:
      the value of the `onKeyPressed` property
    See Also:
      - `setOnKeyPressed(EventHandler)`
      - `onKeyPressedProperty()`

  - ### onKeyPressedProperty

    public final ObjectProperty<EventHandler<? super KeyEvent>> onKeyPressedProperty()
    Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been pressed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Returns:
      the `onKeyPressed` property
    See Also:
      - `getOnKeyPressed()`
      - `setOnKeyPressed(EventHandler)`

  - ### setOnKeyReleased

    public final void setOnKeyReleased(EventHandler<? super KeyEvent> value)
    Sets the value of the `onKeyReleased` property.
    Property description:
      Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been released. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Parameters:
      `value` - the value for the `onKeyReleased` property
    See Also:
      - `getOnKeyReleased()`
      - `onKeyReleasedProperty()`

  - ### getOnKeyReleased

    public final EventHandler<? super KeyEvent> getOnKeyReleased()
    Gets the value of the `onKeyReleased` property.
    Property description:
      Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been released. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Returns:
      the value of the `onKeyReleased` property
    See Also:
      - `setOnKeyReleased(EventHandler)`
      - `onKeyReleasedProperty()`

  - ### onKeyReleasedProperty

    public final ObjectProperty<EventHandler<? super KeyEvent>> onKeyReleasedProperty()
    Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been released. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Returns:
      the `onKeyReleased` property
    See Also:
      - `getOnKeyReleased()`
      - `setOnKeyReleased(EventHandler)`

  - ### setOnKeyTyped

    public final void setOnKeyTyped(EventHandler<? super KeyEvent> value)
    Sets the value of the `onKeyTyped` property.
    Property description:
      Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been typed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Parameters:
      `value` - the value for the `onKeyTyped` property
    See Also:
      - `getOnKeyTyped()`
      - `onKeyTypedProperty()`

  - ### getOnKeyTyped

    public final EventHandler<? super KeyEvent> getOnKeyTyped()
    Gets the value of the `onKeyTyped` property.
    Property description:
      Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been typed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Returns:
      the value of the `onKeyTyped` property
    See Also:
      - `setOnKeyTyped(EventHandler)`
      - `onKeyTypedProperty()`

  - ### onKeyTypedProperty

    public final ObjectProperty<EventHandler<? super KeyEvent>> onKeyTypedProperty()
    Defines a function to be called when some `Node` of this `Scene` has input focus and a key has been typed. The function is called only if the event hasn't been already consumed during its capturing or bubbling phase.
    Returns:
      the `onKeyTyped` property
    See Also:
      - `getOnKeyTyped()`
      - `setOnKeyTyped(EventHandler)`

  - ### setOnInputMethodTextChanged

    public final void setOnInputMethodTextChanged(EventHandler<? super InputMethodEvent> value)
    Sets the value of the `onInputMethodTextChanged` property.
    Property description:
      Defines a function to be called when this `Node` has input focus and the input method text has changed. If this function is not defined in this `Node`, then it receives the result string of the input method composition as a series of `onKeyTyped` function calls.

      When the `Node` loses the input focus, the JavaFX runtime automatically commits the existing composed text if any.

    Parameters:
      `value` - the value for the `onInputMethodTextChanged` property
    See Also:
      - `getOnInputMethodTextChanged()`
      - `onInputMethodTextChangedProperty()`

  - ### getOnInputMethodTextChanged

    public final EventHandler<? super InputMethodEvent> getOnInputMethodTextChanged()
    Gets the value of the `onInputMethodTextChanged` property.
    Property description:
      Defines a function to be called when this `Node` has input focus and the input method text has changed. If this function is not defined in this `Node`, then it receives the result string of the input method composition as a series of `onKeyTyped` function calls.

      When the `Node` loses the input focus, the JavaFX runtime automatically commits the existing composed text if any.

    Returns:
      the value of the `onInputMethodTextChanged` property
    See Also:
      - `setOnInputMethodTextChanged(EventHandler)`
      - `onInputMethodTextChangedProperty()`

  - ### onInputMethodTextChangedProperty

    public final ObjectProperty<EventHandler<? super InputMethodEvent>> onInputMethodTextChangedProperty()
    Defines a function to be called when this `Node` has input focus and the input method text has changed. If this function is not defined in this `Node`, then it receives the result string of the input method composition as a series of `onKeyTyped` function calls.

    When the `Node` loses the input focus, the JavaFX runtime automatically commits the existing composed text if any.

    Returns:
      the `onInputMethodTextChanged` property
    See Also:
      - `getOnInputMethodTextChanged()`
      - `setOnInputMethodTextChanged(EventHandler)`

  - ### getProperties

    public final ObservableMap<Object,Object> getProperties()
    Returns an observable map of properties on this node for use primarily by application developers.
    Returns:
      an observable map of properties on this node for use primarily by application developers
    Since:
      JavaFX 8u40

  - ### hasProperties

    public boolean hasProperties()
    Tests if Scene has properties.
    Returns:
      true if node has properties.
    Since:
      JavaFX 8u40

  - ### setUserData

    public void setUserData(Object value)
    Convenience method for setting a single Object property that can be retrieved at a later date. This is functionally equivalent to calling the getProperties().put(Object key, Object value) method. This can later be retrieved by calling `getUserData()`.
    Parameters:
      `value` - The value to be stored - this can later be retrieved by calling `getUserData()`.
    Since:
      JavaFX 8u40

  - ### getUserData

    public Object getUserData()
    Returns a previously set Object property, or null if no such property has been set using the `setUserData(java.lang.Object)` method.
    Returns:
      The Object that was previously set, or null if no property has been set or if null was set.
    Since:
      JavaFX 8u40

  - ### getPreferences

    public final Scene.Preferences getPreferences()
    Gets the scene preferences that can override `platform` preferences.
    Returns:
      the `Preferences` instance
    Since:
      25

  - ### setNodeOrientation

    public final void setNodeOrientation(NodeOrientation orientation)
    Sets the value of the `nodeOrientation` property.
    Property description:
      Node orientation describes the flow of visual data within a node. In the English speaking world, visual data normally flows from left-to-right. In an Arabic or Hebrew world, visual data flows from right-to-left. This is consistent with the reading order of text in both worlds.
    Default value:
      if the system property `javafx.scene.nodeOrientation.RTL` is `true`, `NodeOrientation.RIGHT_TO_LEFT`, otherwise `NodeOrientation.INHERIT`
    Parameters:
      `orientation` - the value for the `nodeOrientation` property
    Since:
      JavaFX 8.0
    See Also:
      - `getNodeOrientation()`
      - `nodeOrientationProperty()`

  - ### getNodeOrientation

    public final NodeOrientation getNodeOrientation()
    Gets the value of the `nodeOrientation` property.
    Property description:
      Node orientation describes the flow of visual data within a node. In the English speaking world, visual data normally flows from left-to-right. In an Arabic or Hebrew world, visual data flows from right-to-left. This is consistent with the reading order of text in both worlds.
    Default value:
      if the system property `javafx.scene.nodeOrientation.RTL` is `true`, `NodeOrientation.RIGHT_TO_LEFT`, otherwise `NodeOrientation.INHERIT`
    Returns:
      the value of the `nodeOrientation` property
    Since:
      JavaFX 8.0
    See Also:
      - `setNodeOrientation(NodeOrientation)`
      - `nodeOrientationProperty()`

  - ### nodeOrientationProperty

    public final ObjectProperty<NodeOrientation> nodeOrientationProperty()
    Node orientation describes the flow of visual data within a node. In the English speaking world, visual data normally flows from left-to-right. In an Arabic or Hebrew world, visual data flows from right-to-left. This is consistent with the reading order of text in both worlds.
    Default value:
      if the system property `javafx.scene.nodeOrientation.RTL` is `true`, `NodeOrientation.RIGHT_TO_LEFT`, otherwise `NodeOrientation.INHERIT`
    Returns:
      the `nodeOrientation` property
    Since:
      JavaFX 8.0
    See Also:
      - `getNodeOrientation()`
      - `setNodeOrientation(NodeOrientation)`

  - ### getEffectiveNodeOrientation

    public final NodeOrientation getEffectiveNodeOrientation()
    Gets the value of the `effectiveNodeOrientation` property.
    Property description:
      The effective node orientation of a scene resolves the inheritance of node orientation, returning either left-to-right or right-to-left.
    Returns:
      the value of the `effectiveNodeOrientation` property
    Since:
      JavaFX 8.0
    See Also:
      - `effectiveNodeOrientationProperty()`

  - ### effectiveNodeOrientationProperty

    public final ReadOnlyObjectProperty<NodeOrientation> effectiveNodeOrientationProperty()
    The effective node orientation of a scene resolves the inheritance of node orientation, returning either left-to-right or right-to-left.
    Returns:
      the effective node orientation of this scene
    Since:
      JavaFX 8.0
    See Also:
      - `getEffectiveNodeOrientation()`